"use strict";

// キーボード操作コントローラーオブジェクト
var m11RPGwj_KeyController = function() {

	this._key_flag = m11RPGwj_Controller.KEYFLAG_NONE;

	// キー状態を取得
	this.getKeyStatus = function() {
		return this._key_flag;
	}

	// 方向キー状態取得
	this.getStick = function() {
		return this._key_flag & m11RPGwj_Controller.STICK_MASK;
	}

	// ボタンキー状態取得
	this.getButtons = function() {
		return this._key_flag & m11RPGwj_Controller.BUTTONS_MASK;
	}

	this.eventHandler = function(e) {

		var code = 0;

		switch (e.type) {

		case "keydown":

			code = e.keyCode;

			// キー押下状態に応じてキーフラグ設定
			switch (code) {

			// リターンキー
			case 13:

				e.preventDefault();

				this._key_flag |= m11RPGwj_Controller.KEYFLAG_SELECT;

				break;

			// ESCキー
			case 27:

				e.preventDefault();

				this._key_flag |= m11RPGwj_Controller.KEYFLAG_CANCEL;

				break;

			// 上キー
			case 38:

				e.preventDefault();

				this._key_flag |= m11RPGwj_Controller.KEYFLAG_UP;

				break;

			// 下キー
			case 40:

				e.preventDefault();

				this._key_flag |= m11RPGwj_Controller.KEYFLAG_DOWN;

				break;

			// 左キー
			case 37:

				e.preventDefault();

				this._key_flag |= m11RPGwj_Controller.KEYFLAG_LEFT;

				break;

			// 右キー
			case 39:

				e.preventDefault();

				this._key_flag |= m11RPGwj_Controller.KEYFLAG_RIGHT;

				break;

			}

			break;

		case "keyup":

			code = e.keyCode;

			// キー押下状態に応じてキーフラグ設定
			switch (code) {

			// リターンキー
			case 13:

				e.preventDefault();

				this._key_flag &= ~m11RPGwj_Controller.KEYFLAG_SELECT;

				break;

			// ESCキー
			case 27:

				e.preventDefault();

				this._key_flag &= ~m11RPGwj_Controller.KEYFLAG_CANCEL;

				break;

			// 上キー
			case 38:

				e.preventDefault();

				this._key_flag &= ~m11RPGwj_Controller.KEYFLAG_UP;

				break;

			// 下キー
			case 40:

				e.preventDefault();

				this._key_flag &= ~m11RPGwj_Controller.KEYFLAG_DOWN;

				break;

			// 左キー
			case 37:

				e.preventDefault();

				this._key_flag &= ~m11RPGwj_Controller.KEYFLAG_LEFT;

				break;

			// 右キー
			case 39:

				e.preventDefault();

				this._key_flag &= ~m11RPGwj_Controller.KEYFLAG_RIGHT;

				break;

			}

			break;

		}

	}

}
