function m11RPGwj_PlayerItem(src) {

	this.no = -1;
	this.name = null;
	this.type = 0;

	this.field_effect = null;
	this.field_message = null;

	this.battle_effect = null;
	this.battle_message = null;

	this.equip_effect = null;

	this.useNum = 0;

	this.equip = false;

	if (src != null) {

		this.no = src.no;
		this.name = src.name;
		this.type = src.type;

		this.field_effect = src.field_effect;
		this.field_message = src.field_message;

		this.battle_effect = src.battle_effect;
		this.battle_message = src.battle_message;

		this.equip_effect = src.equip_effect;

		this.useNum = src.useNum;

	}

}

m11RPGwj_PlayerItem.ITEMTYPE_GOODS = 0;
m11RPGwj_PlayerItem.ITEMTYPE_1HAND = 1;
m11RPGwj_PlayerItem.ITEMTYPE_ARMOR = 2;
m11RPGwj_PlayerItem.ITEMTYPE_SHIELD = 3;

function m11RPGwj_PlayerItemHolder() {

	this._list = new Array();

	this.getItem = function(index) {
		return this._list[index];
	}

	this.getItemNum = function() {
		return this._list.length;
	}

	this.getNumOfItem = function(no) {

		var i, num = 0;

		for (i = 0;i < this._list.length;i++) {
			if (this._list[i].no == no) {
				num++;
			}
		}

		return num;

	}

	this.getItemSpace = function() {
		return m11RPGwj_PlayerItemHolder.ITEM_MAXNUM - this.getItemNum();
	}

	this.addItem = function(item) {
		if (this.getNumOfItem() < m11RPGwj_PlayerItemHolder.ITEM_MAXNUM) {
			this._list.push(item);
		}
	}

	// 指定アイテムを一つ削除
	this.decItem = function(no) {

		var i, j;

		for (i = 0;i < this._list.length;i++) {
			if (this._list[i].no == no) {

				this._list[i] = null;

				var list = new Array();

				for (j = 0;j < this._list.length;j++) {
					if (this._list[j] != null) {
						list.push(this._list[j]);
					}
				}

				this._list = list;

				return true;

			}
		}

		return false;

	}

	// 指定アイテムの装備状態を設定
	this.setEquip = function(item, equip) {

		var i;

		// 装備するなら同じタイプの装備をすべて外す
		if (equip) {
			for (i = 0;i < this._list.length;i++) {
				if (this._list[i].type == item.type) {
					this._list[i].equip = false;
				}
			}
		}

		item.equip = equip;

	}

	// 指定タイプの装備品を返す
	this.getEquipItem = function(t) {

		var i;

		// 装備品を検索
		for (i = 0;i < this._list.length;i++) {
			if (this._list[i].equip && this._list[i].type == t) {
				return this._list[i];
			}
		}

		return null;

	}

	this.deleteItem = function(item) {

		var i;
		var list = new Array();

		for (i = 0;i < this._list.length;i++) {
			if (this._list[i] != item) {
				list.push(this._list[i]);
			}
		}

		delete this._list;

		this._list = list;

	}

	this.getItemData = function() {

		var i;

		var data = new String();

		for (i = 0;i < this._list.length;i++) {
			if (this._list[i]) {

				if (data.length > 0) {
					data += "\t";
				}

				data += this._list[i].no + ',' + this._list[i].useNum;

				if (this._list[i].equip) {
					data += ',' + '1';
				} else {
					data += ',' + '0';
				}

			}
		}

		return data;

	}

}

m11RPGwj_PlayerItemHolder.ITEM_MAXNUM = 8;
