// スクリプト実行状態保持オブジェクト
function m11RPGwj_ScriptContext() {

	// スクリプトコード実行位置
	this.pos = 0;

	// 実行中コード配列
	this.list = null;

	this.status = m11RPGwj_ScriptContext.SCRIPTSTATE_NONE;
	this.stage = 0;
	this.if_level = 0;

	this.caller_context = null;

	// コンテキスト用ローカル変数
	this.localVar = new Array(16);

	var i;

	for (i = 0;i < 16;i++) {
		this.localVar[i] = 0;
	}

}

m11RPGwj_ScriptContext.createScriptContext = function(list, context) {

	if (list == null) {
		return null;
	}

	var obj = new m11RPGwj_ScriptContext();

	var item;

	if (list instanceof m11RPGwj_ScriptCode) {

		item = new m11RPGwj_ScriptCode();

		item.name = new String(list.name);
		item.args = list.copyArgs();

		obj.list = new Array();

		obj.list.push(item);

	}

	if (list instanceof Array) {

		obj.list = new Array();

		var i;

		for (i = 0;i < list.length;i++) {

			item = new m11RPGwj_ScriptCode();

			item.name = new String(list[i].name);
			item.args = list[i].copyArgs();

			obj.list.push(item);

		}

	}

	obj.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODELOAD;

	obj.caller_context = context;

	return obj;

}

// スクリプト処理状態
m11RPGwj_ScriptContext.SCRIPTSTATE_NONE = 0;
m11RPGwj_ScriptContext.SCRIPTSTATE_CODELOAD = 1;
m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXEC = 2;
m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT = 3;

// スクリプト関数処理段階
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_NONE = 0;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_LOADING = 1;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_LOADED = 2;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_VIEW = 3;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_EXIT = 4;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_LOADING = 5;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_LOADED = 6;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_VIEW = 7;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_EXIT = 8;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BGM_LOADING = 9;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BGM_LOADED = 10;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_START = 11;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_COMMAND_IN = 12;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_COMMAND = 13;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_PLAYERATTACK_IN = 14;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_PLAYERCANSEL_MESSAGE = 15;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_PLAYERACTION_MESSAGE = 16;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ENEMYATTACK_IN = 17;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ENEMYATTACK = 18;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_WIN_IN = 19;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_WIN = 20;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ESCAPE_IN = 21;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ESCAPE = 22;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_LOSE_IN = 23;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_LOSE = 24;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_EXIT = 25;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ITEMMENU = 26;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ITEMMENU_DONE = 27;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_MAGICMENU = 28;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_MAGICMENU_DONE = 29;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_FLASH_IN = 30;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_FLASH = 31;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_FLASH_OUT = 32;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MESSAGE_VIEW = 33;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MESSAGE_EXIT = 34;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MOVE_BLACKOUT_IN = 35;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MOVE_BLACKOUT = 36;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MOVE_BLACKOUT_OUT = 37;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MOVE_EXIT = 38;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_END = 39;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_IMAGELOADING = 40;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_IMAGELOADED = 41;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_MUSICLOADING = 42;
m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_MUSICLOADED = 43;

m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTEXEC = 1;
m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTBREAK = 2;
m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTEXIT = 3;

