// ゲーム画面ウインドウ基本クラス
var m11RPGwj_Window = function() {

	// 表示位置
	this._x = 0;
	this._y = 0;

	// ウインドウの大きさ
	this._width = m11RPGwj_Window.DEFAULT_WIDTH;
	this._height = m11RPGwj_Window.DEFAULT_HEIGHT;

	this._client_x = this._x + m11RPGwj_Window.FRAME_BORDER_SIZE;
	this._client_y = this._y + m11RPGwj_Window.FRAME_BORDER_SIZE;

	this._client_width = this._width - m11RPGwj_Window.FRAME_BORDER_SIZE * 2;
	this._client_height = this._height - m11RPGwj_Window.FRAME_BORDER_SIZE * 2;

	this._visible = false;

	this._backRGB = '#000000';
	this._active = false;

	this._frameRGB = '#ffffff';

	this._textRGB = '#ffffff';

	this._font = m11RPGwj_Window.DEFAULT_FONT;

}

m11RPGwj_Window.prototype.setPos = function(x, y) {

	this._x = x;
	this._y = y;

	this._client_x = this._x + m11RPGwj_Window.FRAME_BORDER_SIZE;
	this._client_y = this._y + m11RPGwj_Window.FRAME_BORDER_SIZE;

}

m11RPGwj_Window.prototype.setSize = function(width, height) {

	this._width = width;
	this._height = height;

	this._client_width = this._width - m11RPGwj_Window.FRAME_BORDER_SIZE * 2;
	this._client_height = this._height - m11RPGwj_Window.FRAME_BORDER_SIZE * 2;

}

m11RPGwj_Window.prototype.setClientSize = function(width, height) {

	this._client_width = width;
	this._client_height = height;

	this._width = this._client_width + m11RPGwj_Window.FRAME_BORDER_SIZE * 2;
	this._height = this._client_height + m11RPGwj_Window.FRAME_BORDER_SIZE * 2;

}

// 可視状態に
m11RPGwj_Window.prototype.show = function() {
	this._visible = true;
}

// 不可視状態に
m11RPGwj_Window.prototype.hide = function() {
	this._visible = false;
}

	// 描画時のX座標取得
m11RPGwj_Window.prototype.getX = function() {
	return this._x;
}

	// 描画時のY座標取得
m11RPGwj_Window.prototype.getY = function() {
	return this._y;
}

	// 描画時の横幅取得
m11RPGwj_Window.prototype.getWidth = function() {
	return this._width;
}

// 描画時の高さ取得
m11RPGwj_Window.prototype.getHeight = function() {
	return this._height;
}

m11RPGwj_Window.prototype.draw = function(context) {

	if (!this._visible) {
		return;
	}

	// ウインドウ領域全体をフレーム色でクリア
	context.fillStyle = this._frameRGB;
	context.fillRect(this._x, this._y, this._width, this._height);

	// 内側を背景色でクリア
	context.fillStyle = this._backRGB;
	context.fillRect(this._client_x, this._client_y, this._client_width, this._client_height);

}

m11RPGwj_Window.DEFAULT_WIDTH = 64;
m11RPGwj_Window.DEFAULT_HEIGHT = 64;
m11RPGwj_Window.DEFAULT_FONT = "14px monospace";

m11RPGwj_Window.FRAME_BORDER_SIZE = 2;

m11RPGwj_Window.FORE_FRAME_RGB = '#ffffff';
m11RPGwj_Window.BACK_FRAME_RGB = '#cccccc';
