/*
	Webブラウザ版11式RPG制作機 04

	2012-11-28 創作プログラミングの街
*/

// 初期化関数登録
window.onload = m11RPGwj_init;

var m11RPGwj_data = new m11RPGwj_GameData();
var m11RPGwj_playerStatus = new m11RPGwj_GameStatus();
var m11RPGwj_systemStatus = new m11RPGwj_SystemStatus();

var m11RPGwj_config = new Object();

var m11RPGwj_loadDataList;

var m11RPGwj_resManager = new m11RPGwj_ResourceManager();

// ゲーム出力領域保持用DIVタグ出力
document.write('<div id="m11RPGwj_holder"></div>');

// 開始処理
function m11RPGwj_init() {

	m11RPGwj_systemStatus.app_status = m11RPGwj_SystemStatus.APPSTATE_NONE;

	// 実行している端末種別
	m11RPGwj_config.deviceType = "pc";

	if (navigator.userAgent.indexOf("iPhone") > 0 || navigator.userAgent.indexOf("iPad") > 0) {
		m11RPGwj_config.deviceType = "iOS";
	}

	if (navigator.userAgent.indexOf("Android") > 0) {
		m11RPGwj_config.deviceType = "Android";
	}

	// 設定ファイル読み込み開始（読み込んだらm11RPGwj_initSystem()を実行）
	m11RPGwj_resManager.loadText("config.dat", function() { m11RPGwj_initSystem(); });

}

// 各種初期設定
function m11RPGwj_initSystem() {

	// 設定ファイルの内容を反映
	m11RPGwj_loadConfig(m11RPGwj_resManager.getItem("config.dat").item);

	// パソコン用設定
	if (m11RPGwj_config.deviceType == "pc") {

		m11RPGwj_config.status_font = "14px monospace";
		m11RPGwj_config.status_char_width = 17;

		m11RPGwj_systemStatus.scroll_pixel = 1;

		m11RPGwj_config.default_frame_ms = 20;

		m11RPGwj_data.chip_imageList = null;

	}

	// iOS用設定
	if (m11RPGwj_config.deviceType == "iOS") {

		m11RPGwj_config.status_font = "14px monospace";
		m11RPGwj_config.status_char_width = 17;

		m11RPGwj_config.default_frame_ms = 30;

		if (navigator.userAgent.indexOf("OS 6") > 0) {

			m11RPGwj_data.chip_imageList = null;
			m11RPGwj_systemStatus.scroll_pixel = 2;

		} else {

			m11RPGwj_data.chip_imageList = new Array();
			m11RPGwj_systemStatus.scroll_pixel = 4;

		}

	}

	// Android用設定
	if (m11RPGwj_config.deviceType == "Android") {

		m11RPGwj_config.status_font = "14px monospace";
		m11RPGwj_config.status_char_width = 17;

		m11RPGwj_systemStatus.scroll_pixel = 2;

		m11RPGwj_config.default_frame_ms = 30;

		m11RPGwj_data.chip_imageList = new Array();

	}

	m11RPGwj_systemStatus.frame_ms = m11RPGwj_config.default_frame_ms;

	// 主人公ステータス描画領域の高さ
	m11RPGwj_config.status_height = 24;

	m11RPGwj_systemStatus.v_cols = m11RPGwj_config.view_cols;
	m11RPGwj_systemStatus.v_rows = m11RPGwj_config.view_rows;

	m11RPGwj_config.view_center_x = (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) / 2;
	m11RPGwj_config.view_center_y = (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) / 2;

	// 主人公描画位置設定
	m11RPGwj_config.chr_x = m11RPGwj_config.chip_width * Math.floor(m11RPGwj_config.view_cols / 2);
	m11RPGwj_config.chr_y = m11RPGwj_config.chip_height * Math.floor(m11RPGwj_config.view_rows / 2);

	m11RPGwj_config.view_range_x = Math.floor(m11RPGwj_config.view_cols / 2);
	m11RPGwj_config.view_range_y = Math.floor(m11RPGwj_config.view_rows / 2);

	// ゲーム画面描画用canvasタグ
	var cv_tag = '<canvas id="viewCanvasElement" width="' + (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) + '" height="' + (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows + m11RPGwj_config.status_height) + '" style="background: ' + m11RPGwj_systemStatus.bg_color + '; position: absolute; left: 2px; top: 2px; z-index: 1;"></canvas>';

	// 動画再生用videoタグ
	var video_tag = '<video id="videoPlayerElement" style="position: absolute; left: 4px; top: 0px; z-index: 2; visibility: hidden;"></video>';

	var menu_tag = '<div style="position: static; width: ' + (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols + 4) + 'px; text-align: center; padding: 0;"><select id="m11RPGwj_soundMenu" onchange="m11RPGwj_soundMenuChange()"><option value="on">音声あり</option><option value="off">音声なし</option></select><button id="startButton" onclick="m11RPGwj_startGame()">開始</button></div>';

	var game_tag = '<div style="position: static; margin-left: auto; margin-right: auto; width: ' + (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols + 4) + 'px;"><div style="position: relative; width: ' + (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols + 4) + 'px; height: ' + (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows + m11RPGwj_config.status_height + 4) + 'px; background: #000000;">' + cv_tag + video_tag + '</div>' + menu_tag + '</div>';

	document.getElementById("m11RPGwj_holder").innerHTML = game_tag;

	// canvas要素の参照を保存
	m11RPGwj_systemStatus.viewCanvas = document.getElementById("viewCanvasElement");
	m11RPGwj_systemStatus.viewContext = m11RPGwj_systemStatus.viewCanvas.getContext("2d");

	// 動画再生用video要素の参照を保存
	m11RPGwj_systemStatus.videoPlayer = document.getElementById("videoPlayerElement");

	m11RPGwj_systemStatus.app_status = m11RPGwj_SystemStatus.APPSTATE_DEMO;

	// メイン処理開始
	m11RPGwj_process();

}

// 音声メニュー変更時
function m11RPGwj_soundMenuChange() {

	// メニューのフォーカスを外す
	document.getElementById("m11RPGwj_soundMenu").blur();

	// 音声のミュート設定
	m11RPGwj_soundMenuSync();

}

// 音声出力ミュート設定取得
function m11RPGwj_getMuteSetting() {

	if (document.getElementById("m11RPGwj_soundMenu").value == 'off') {
		return true;
	}

	return false;

}

// 音声メニューに応じて音声出力のミュート設定
function m11RPGwj_soundMenuSync() {

	if (m11RPGwj_getMuteSetting()) {

		if (m11RPGwj_systemStatus.bgmPlayer != null) {
			m11RPGwj_systemStatus.bgmPlayer.muted = true;
		}

		if (m11RPGwj_systemStatus.videoPlayer != null) {
			m11RPGwj_systemStatus.videoPlayer.muted = true;
		}

	} else {

		if (m11RPGwj_systemStatus.bgmPlayer != null) {
			m11RPGwj_systemStatus.bgmPlayer.muted = false;
		}

		if (m11RPGwj_systemStatus.videoPlayer != null) {
			m11RPGwj_systemStatus.videoPlayer.muted = false;
		}

	}

}

function m11RPGwj_setBGM(bgm_name) {

	if (bgm_name == null || bgm_name.length < 1) {
		m11RPGwj_playerStatus.bgm = null;
	} else {
		m11RPGwj_playerStatus.bgm = bgm_name;
	}

	if (m11RPGwj_systemStatus.bgmPlayer != null) {

		m11RPGwj_systemStatus.bgmPlayer.pause();
		delete m11RPGwj_systemStatus.bgmPlayer;

		m11RPGwj_systemStatus.bgmPlayer = null;

	}

	if (m11RPGwj_playerStatus.bgm == null || (m11RPGwj_config.deviceType == "iOS" && m11RPGwj_getMuteSetting())) {
		return;
	}

	// 再生用Audioオブジェクト作成
	try {
		m11RPGwj_systemStatus.bgmPlayer = new Audio();
	} catch(e) {
		m11RPGwj_systemStatus.bgmPlayer = null;
	}

	if (m11RPGwj_systemStatus.bgmPlayer != null) {

		m11RPGwj_soundMenuSync();

		var file_name;

		// 再生ファイルの形式（拡張子）決定
		if (m11RPGwj_systemStatus.bgmPlayer.canPlayType("audio/ogg") == "maybe" || m11RPGwj_systemStatus.bgmPlayer.canPlayType("audio/ogg") == "probably") {
			file_name = bgm_name + ".ogg";
		} else {
			file_name = bgm_name + ".m4a";
		}

		m11RPGwj_systemStatus.bgmPlayer.addEventListener("ended", function() {

			m11RPGwj_systemStatus.bgmPlayer.currentTime = 0;
			m11RPGwj_systemStatus.bgmPlayer.play(); 

		}, false);

		m11RPGwj_systemStatus.bgmPlayer.src = file_name;

		if (m11RPGwj_config.deviceType == "iOS") {

			m11RPGwj_systemStatus.bgmPlayer.load();
			m11RPGwj_systemStatus.bgmPlayer.play();

		} else {

			m11RPGwj_systemStatus.bgmPlayer.addEventListener("canplay", function() {
				m11RPGwj_systemStatus.bgmPlayer.play();
			}, false);

			m11RPGwj_systemStatus.bgmPlayer.load();

		}

	}

}

function m11RPGwj_playMusic(music_name) {

	if (m11RPGwj_systemStatus.bgmPlayer != null) {

		m11RPGwj_systemStatus.bgmPlayer.pause();
		delete m11RPGwj_systemStatus.bgmPlayer;

		m11RPGwj_systemStatus.bgmPlayer = null;

	}

	if (music_name == null || music_name.length < 1) {

		m11RPGwj_setBGM(m11RPGwj_playerStatus.bgm);

		return;

	}

	if (m11RPGwj_config.deviceType == "iOS" && m11RPGwj_getMuteSetting()) {
		return;
	}

	// 再生用Audioオブジェクト作成
	try {
		m11RPGwj_systemStatus.bgmPlayer = new Audio();
	} catch(e) {
		m11RPGwj_systemStatus.bgmPlayer = null;
	}

	if (m11RPGwj_systemStatus.bgmPlayer != null) {

		m11RPGwj_soundMenuSync();

		var file_name;

		// 再生ファイルの形式（拡張子）決定
		if (m11RPGwj_systemStatus.bgmPlayer.canPlayType("audio/ogg") == "maybe" || m11RPGwj_systemStatus.bgmPlayer.canPlayType("audio/ogg") == "probably") {
			file_name = music_name + ".ogg";
		} else {
			file_name = music_name + ".m4a";
		}

		m11RPGwj_systemStatus.bgmPlayer.loop = "false";

		m11RPGwj_systemStatus.bgmPlayer.src = file_name;

		if (m11RPGwj_config.deviceType == "iOS") {

			m11RPGwj_systemStatus.bgmPlayer.load();
			m11RPGwj_systemStatus.bgmPlayer.play();

		} else {

			m11RPGwj_systemStatus.bgmPlayer.addEventListener("canplay", function() {
				m11RPGwj_systemStatus.bgmPlayer.play();
			}, false);

			m11RPGwj_systemStatus.bgmPlayer.load();

		}

	}

}

function m11RPGwj_startGame() {

	document.getElementById("startButton").blur();

	document.getElementById("startButton").disabled = true;

	// パソコン用コントローラー（キーボードのみ）作成
	if (m11RPGwj_config.deviceType == "pc") {

		m11RPGwj_Controller.createController(m11RPGwj_Controller.KEYBOARD_TYPE);

		m11RPGwj_systemStatus.controller = m11RPGwj_Controller.controller;

	}

	// iOS／Android端末用コントローラー（タッチ／キーボード両対応）作成
	if (m11RPGwj_config.deviceType == "iOS" || m11RPGwj_config.deviceType == "Android") {

		m11RPGwj_Controller.createController(m11RPGwj_Controller.KEYBOARD_TYPE | m11RPGwj_Controller.TOUCH_TYPE);

		m11RPGwj_systemStatus.controller = m11RPGwj_Controller.controller;

		m11RPGwj_systemStatus.controller.setParent(m11RPGwj_systemStatus.viewCanvas);

		m11RPGwj_systemStatus.controller.setPos(m11RPGwj_systemStatus.viewCanvas.width - (m11RPGwj_systemStatus.controller.getWidth() + 2), m11RPGwj_config.chip_height * m11RPGwj_config.view_rows - (m11RPGwj_systemStatus.controller.getHeight() + 2));
		// タッチイベントハンドラ設定
		document.addEventListener("touchstart", function(e) { m11RPGwj_Controller.controller.eventHandler(e); }, false);
		document.addEventListener("touchmove", function(e) { m11RPGwj_Controller.controller.eventHandler(e); }, false);
		document.addEventListener("touchend", function(e) { m11RPGwj_Controller.controller.eventHandler(e); }, false);

	}

	document.addEventListener("keydown", function(e) { m11RPGwj_Controller.controller.eventHandler(e); }, false);
	document.addEventListener("keyup", function(e) { m11RPGwj_Controller.controller.eventHandler(e); }, false);

	// 読み込み状態に入る
	m11RPGwj_systemStatus.app_status = m11RPGwj_SystemStatus.APPSTATE_LOADING;
	m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_MAPLIST;

	// リソース画像ファイルリスト
	m11RPGwj_config.resourceImageNameList = new Array();

	m11RPGwj_config.resourceImageNameList.push(m11RPGwj_config.charImage);
	m11RPGwj_config.resourceImageNameList.push(m11RPGwj_config.chipImage);

	m11RPGwj_systemStatus.scriptMeswin = new m11RPGwj_MessageWindow();
	m11RPGwj_systemStatus.scriptSelectDlg = new m11RPGwj_SelectDialog();

	m11RPGwj_systemStatus.titleDlg = new m11RPGwj_SelectDialog();
	m11RPGwj_systemStatus.commandDlg = new m11RPGwj_SelectDialog();
	m11RPGwj_systemStatus.commandMessage = new m11RPGwj_MessageWindow();
	m11RPGwj_systemStatus.magicDlg = new m11RPGwj_SelectDialog();
	m11RPGwj_systemStatus.itemDlg = new m11RPGwj_ItemDialog();

}

// ゲームを駆動するメイン関数
function m11RPGwj_process() {

	// 処理開始時刻を記録
	var start_ms = (new Date()).getTime();

	switch (m11RPGwj_systemStatus.app_status) {

	case m11RPGwj_SystemStatus.APPSTATE_LOADING:

		m11RPGwj_loadData();

		break;

	case m11RPGwj_SystemStatus.APPSTATE_TITLE:

		m11RPGwj_title();

		break;

	case m11RPGwj_SystemStatus.APPSTATE_START:

		m11RPGwj_start();

		break;

	case m11RPGwj_SystemStatus.APPSTATE_GAME:

		while (m11RPGwj_game());

		break;

	case m11RPGwj_SystemStatus.APPSTATE_END:

		break;

	}

	// 現在の状態をブラウザ上に描画
	if (m11RPGwj_systemStatus.viewContext != null) {
		m11RPGwj_draw(m11RPGwj_systemStatus.viewContext);
	}

	m11RPGwj_systemStatus.process_count++;

	// 今回の処理時間を算出
	var process_ms = (new Date()).getTime() - start_ms;

	// 処理時間からウエイトを算出
	var wait = m11RPGwj_systemStatus.frame_ms - (process_ms + 3);

	if (wait < 3) {
		wait = 3;
	}

	if (wait > m11RPGwj_systemStatus.frame_ms) {
		wait = m11RPGwj_systemStatus.frame_ms;
	}

	// ウエイトを入れてから再びm11RPGwj_process()を呼び出す
	setTimeout("m11RPGwj_process()", wait);

}

function m11RPGwj_title() {

	switch (m11RPGwj_systemStatus.process_status) {

	case 0:

		m11RPGwj_systemStatus.loading_image = new Image();

		m11RPGwj_systemStatus.loading_image.onload = function () { m11RPGwj_systemStatus.process_status = 1; }

		m11RPGwj_systemStatus.loading_image.src = m11RPGwj_config.title_image;

		break;

	case 1:

		if (m11RPGwj_config.title_music != null) {
			m11RPGwj_playMusic(m11RPGwj_config.title_music);
		}

		m11RPGwj_systemStatus.process_status = 2;

		break;

	case 2:

		m11RPGwj_systemStatus.loaded_image = m11RPGwj_systemStatus.loading_image;
		m11RPGwj_systemStatus.loading_image = null;

		m11RPGwj_systemStatus.process_status = 3;

		break;

	case 3:

		if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_SELECT) {

			m11RPGwj_setBGM(null);

			if (m11RPGwj_systemStatus.loaded_image != null) {

				delete m11RPGwj_systemStatus.loaded_image;

				m11RPGwj_systemStatus.loaded_image = null;

			}

			m11RPGwj_systemStatus.app_status = m11RPGwj_SystemStatus.APPSTATE_START;
			m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.STARTSTATE_INIT;

		}

		break;

	}

}

function m11RPGwj_start() {

	var i, j;

	switch (m11RPGwj_systemStatus.game_status) {

	case m11RPGwj_SystemStatus.STARTSTATE_INIT:

		if (m11RPGwj_data.chip_imageList != null) {

			var imgDataFlag = true;

			var cv = document.createElement("canvas");

			cv.width = m11RPGwj_config.chip_width;
			cv.height = m11RPGwj_config.chip_height;

			var context = cv.getContext("2d");

			// マップ地形画像を切り分け描画用ImageData配列作成
			for (i = 0;i < 64;i++) {

				context.drawImage(m11RPGwj_data.chipImage, (i % 8) * m11RPGwj_config.chip_width, Math.floor(i / 8) * m11RPGwj_config.chip_height, m11RPGwj_config.chip_width, m11RPGwj_config.chip_height, 0, 0, m11RPGwj_config.chip_width, m11RPGwj_config.chip_height);

				var imgData = m11RPGwj_systemStatus.viewContext.createImageData(m11RPGwj_config.chip_width, m11RPGwj_config.chip_height);

				var srcData = null;

				try {

					srcData = cv.getContext('2d').getImageData(0, 0, m11RPGwj_config.chip_width, m11RPGwj_config.chip_height);

					for (j = 0;j < imgData.data.length;j++) {
						imgData.data[j] = srcData.data[j];
					}

				} catch (e) {

					imgData = null;

					imgDataFlag = false;

				}

				srcData= null;

				m11RPGwj_data.chip_imageList[i] = imgData;

			}

			if ((m11RPGwj_data.chip_imageList != null) && (!imgDataFlag)) {

				delete m11RPGwj_data.chip_imageList;
				m11RPGwj_data.chip_imageList = null;

			}

		}

		m11RPGwj_updateStatus();

		var saveCheck = 0;

		// セーブデータがあれば、バージョン検証
		if (localStorage && localStorage.getItem("m11RPGwj_saveData")) {

			var data = localStorage.getItem("m11RPGwj_saveData").replace("\r\n", "\n");
			data = data.replace("\r", "\n");

			// 行ごとに配列に切り分ける
			var dataLineList = data.split("\n");

			var lineItems;

			// データ文字列の各項目を読み取り
			for (i = 0;i < dataLineList.length;i++) {

				// 「=」区切りを分離し個々の設定項目を取得
				lineItems = dataLineList[i].split("=");

				if (lineItems.length == 2) {

					switch (lineItems[0]) {

					case 'gameID':

						if (lineItems[1] == null || lineItems[1].length < 1) {
							if (m11RPGwj_config.gameID == null) {
								saveCheck++;
							}
						} else {
							if (lineItems[1] == m11RPGwj_config.gameID) {
								saveCheck++;
							}
						}

						break;

					case 'saveVer':

						if (lineItems[1] == null || lineItems[1].length < 1) {
							if (m11RPGwj_config.saveVer == null) {
								saveCheck++;
							}
						} else {
							if (lineItems[1] == m11RPGwj_config.saveVer) {
								saveCheck++;
							}
						}

						break;

					case 'formatVer':

						if (lineItems[1] == '1') {
							saveCheck++;
						}

						break;

					}

				}

			}

		}

		// 有効なセーブデータがあればメニューへ
		if (saveCheck == 3) {

			var list = new Array();

			list.push("はじめから");
			list.push("続きから");

			m11RPGwj_systemStatus.titleDlg.reset();

			m11RPGwj_systemStatus.titleDlg.setItems(list, m11RPGwj_systemStatus.viewContext);
			m11RPGwj_systemStatus.titleDlg.setCancelable(false);
			m11RPGwj_systemStatus.titleDlg.setIndex(1);

			var winx = ((m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) - m11RPGwj_systemStatus.titleDlg.getWidth()) / 2;
			var winy = ((m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) - m11RPGwj_systemStatus.titleDlg.getHeight()) / 2;

			m11RPGwj_systemStatus.titleDlg.setPos(winx, winy);

			m11RPGwj_systemStatus.titleDlg.show();

			// ダイアログ選択待機状態へ
			m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.STARTSTATE_MENU;


		} else {

			// 無効なセーブデータがあれば削除
			if (localStorage && localStorage.getItem("m11RPGwj_saveData")) {
				localStorage.removeItem("m11RPGwj_saveData");
			}

			m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.STARTSTATE_DONE;

		}

		break;

	case m11RPGwj_SystemStatus.STARTSTATE_MENU:

		if (m11RPGwj_systemStatus.titleDlg.process(m11RPGwj_systemStatus.controller)) {

			// 新規ゲーム
			if (m11RPGwj_systemStatus.titleDlg.getIndex() == 0 && localStorage && localStorage.getItem("m11RPGwj_saveData")) {
				localStorage.removeItem("m11RPGwj_saveData");
			}

			m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.STARTSTATE_DONE;

		}

		break;

	case m11RPGwj_SystemStatus.STARTSTATE_DONE:

		m11RPGwj_systemStatus.app_status = m11RPGwj_SystemStatus.APPSTATE_GAME;

		m11RPGwj_playerStatus.bgm = null;

		// セーブデータがあれば、セーブデータで再開
		if (localStorage && localStorage.getItem("m11RPGwj_saveData")) {

			var data = localStorage.getItem("m11RPGwj_saveData").replace("\r\n", "\n");
			data = data.replace("\r", "\n");

			// 行ごとに配列に切り分ける
			var dataLineList = data.split("\n");

			var lineItems;

			// データ文字列の各項目を読み取り
			for (i = 0;i < dataLineList.length;i++) {

				// 「=」区切りを分離し個々の設定項目を取得
				lineItems = dataLineList[i].split("=");

				if (lineItems.length == 2) {

					switch (lineItems[0]) {

					case 'status':

						m11RPGwj_playerStatus.setStatusData(lineItems[1]);

						break;

					case 'item':

						var savedItemList = lineItems[1].split("\t");

						for (j = 0;j < savedItemList.length;j++) {

							var itemParams = savedItemList[j].split(",");

							var item_no = parseInt(itemParams[0]);
							var item_useNum = parseInt(itemParams[1]);
							var item_equip = false;

							if (parseInt(itemParams[2]) == 1) {
								item_equip = true;
							}

							if (item_no >= 0 && item_no < 16) {

								var add_item = new m11RPGwj_PlayerItem(m11RPGwj_data.playerItemList[item_no]);
								add_item.useNum = item_useNum;

								m11RPGwj_playerStatus.itemHolder.addItem(add_item);

								m11RPGwj_playerStatus.itemHolder.setEquip(add_item, item_equip);

							}

						}

						break;

					case 'vars':

						var savedVars = lineItems[1].split(",");

						for (j = 0;j < savedVars.length;j++) {
							m11RPGwj_playerStatus.varList[j] = savedVars[j];
						}

						break;

					case 'bgm':

						if (lineItems[1]) {
							m11RPGwj_playerStatus.bgm = lineItems[1];
						}

						break;

					}

				}

			}

			m11RPGwj_systemStatus.v_x = m11RPGwj_playerStatus.x;
			m11RPGwj_systemStatus.v_y = m11RPGwj_playerStatus.y;

			// BGM再生指定があれば、BGM再生スクリプト設定
			if (m11RPGwj_playerStatus.bgm != null) {
				m11RPGwj_setBGM(m11RPGwj_playerStatus.bgm);
			}

			// マップ通常状態へ
			m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.GMAESTATE_WALK;

		} else {

			// スクリプト変数を初期化
			for (i = 0;i < m11RPGwj_playerStatus.varList.length;i++) {
				m11RPGwj_playerStatus.varList[i] = 0;
			}

			// HP/MPを最大値に
			m11RPGwj_playerStatus.status.hp = m11RPGwj_playerStatus.status.mhp;
			m11RPGwj_playerStatus.status.mp = m11RPGwj_playerStatus.status.mmp;

			// 開始時イベントの指定があれば、イベント実行状態へ
			if (m11RPGwj_config.start_event >= 0) {

				m11RPGwj_systemStatus.scriptContext = m11RPGwj_ScriptContext.createScriptContext(m11RPGwj_data.eventList[m11RPGwj_config.start_event].scriptList, null);

				// スクリプト処理中状態へ移行
				m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.GMAESTATE_SCRIPT;

			} else {
				// マップ通常状態へ
				m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.GMAESTATE_WALK;
			}

		}

		break;

	}

}

function m11RPGwj_game() {

	var script_result;

	switch (m11RPGwj_systemStatus.game_status) {

	// 通常（マップ表示・スクロール処理）時
	case m11RPGwj_SystemStatus.GMAESTATE_WALK:

		// 一チップ分スクロールが終了したらウエイトなしで次のprocess()
		if (m11RPGwj_walk()) {
			return true;
		}

		break;

	// スクリプト処理中
	case m11RPGwj_SystemStatus.GMAESTATE_SCRIPT:

		// スクリプト処理
		do {

			script_result = m11RPGwj_script(m11RPGwj_systemStatus.scriptContext);

			// スクリプトの処理が終わったらイベントを終えてマップ移動状態へ
			if (script_result == m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTEXIT) {

				// スクリプト処理中の呼び出しなら、呼び出し元へ制御を戻す
				if (m11RPGwj_systemStatus.scriptContext.caller_context != null) {
					m11RPGwj_systemStatus.scriptContext = m11RPGwj_systemStatus.scriptContext.caller_context;
				} else {
					m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.GMAESTATE_WALK;
				}

			}

		} while(script_result == m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTEXEC);

		break;

	// コマンドモード
	case m11RPGwj_SystemStatus.GMAESTATE_COMMAND:

		if (m11RPGwj_command()) {
			m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.GMAESTATE_WALK;
		}

		break;

	}

	return false;

}

// データ読み込み
function m11RPGwj_loadData() {

	var items;

	var data;
	var i;

	switch (m11RPGwj_systemStatus.loading_status) {

	// マップデータ読み込みを開始
	case m11RPGwj_SystemStatus.LOADINGSTATE_MAPLIST:

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_MAPLIST_LOADING;

		m11RPGwj_resManager.loadText("maplist.dat", function() { m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_MAPLIST_LOADED; });

		break;

	// 読み込んだマップデータを元にマップ情報設定
	case m11RPGwj_SystemStatus.LOADINGSTATE_MAPLIST_LOADED:

		m11RPGwj_loadMapList(m11RPGwj_resManager.getItem("maplist.dat").item);

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_MAPDATA;

		break;

	// マップ用データファイル読み込みを開始
	case m11RPGwj_SystemStatus.LOADINGSTATE_MAPDATA:

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_MAPDATA_LOADING;

		for (i = 0;i < m11RPGwj_loadDataList.length;i++) {
			m11RPGwj_resManager.loadText(m11RPGwj_loadDataList[i], m11RPGwj_loadMapData);
		}

		break;

	// マップ用データを設定
	case m11RPGwj_SystemStatus.LOADINGSTATE_MAPDATA_LOADED:

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_EVENT;

		break;

	// イベント情報取得を開始
	case m11RPGwj_SystemStatus.LOADINGSTATE_EVENT:

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_EVENT_LOADING;

		m11RPGwj_resManager.loadText("event.dat", function() { m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_EVENT_LOADED; });

		break;

	// 読み込んだデータからイベントテーブルを作成
	case m11RPGwj_SystemStatus.LOADINGSTATE_EVENT_LOADED:

		m11RPGwj_loadEvent(m11RPGwj_resManager.getItem("event.dat").item);

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_ENEMY;

		break;

	// 敵情報読み込みを開始
	case m11RPGwj_SystemStatus.LOADINGSTATE_ENEMY:

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_ENEMY_LOADING;

		m11RPGwj_resManager.loadText("enemy.dat", function() { m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_ENEMY_LOADED; });

		break;

	// 読み込んだデータから敵データを作成
	case m11RPGwj_SystemStatus.LOADINGSTATE_ENEMY_LOADED:

		m11RPGwj_loadEnemy(m11RPGwj_resManager.getItem("enemy.dat").item);

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_PLAYERITEM;

		break;

	// アイテム情報読み込みを開始
	case m11RPGwj_SystemStatus.LOADINGSTATE_PLAYERITEM:

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_PLAYERITEM_LOADING;

		m11RPGwj_resManager.loadText("playeritem.dat", function() { m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_PLAYERITEM_LOADED; });

		break;

	// 読み込んだデータからアイテムデータを作成
	case m11RPGwj_SystemStatus.LOADINGSTATE_PLAYERITEM_LOADED:

		m11RPGwj_loadItemList(m11RPGwj_resManager.getItem("playeritem.dat").item);

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_MAGIC;

		break;

	// 魔法一覧読み込みを開始
	case m11RPGwj_SystemStatus.LOADINGSTATE_MAGIC:

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_MAGIC_LOADING;

		m11RPGwj_resManager.loadText("magiclist.dat", function() { m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_MAGIC_LOADED; });

		break;

	case m11RPGwj_SystemStatus.LOADINGSTATE_MAGIC_LOADED:

		m11RPGwj_loadMagicList(m11RPGwj_resManager.getItem("magiclist.dat").item);

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_PLAYERSTATUS;

		break;

	// ステータス情報読み込みを開始
	case m11RPGwj_SystemStatus.LOADINGSTATE_PLAYERSTATUS:

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_PLAYERSTATUS_LOADING;

		m11RPGwj_resManager.loadText("playerstatus.dat", function() { m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_PLAYERSTATUS_LOADED; });

		break;

	// 読み込んだデータから主人公ステータスデータを作成
	case m11RPGwj_SystemStatus.LOADINGSTATE_PLAYERSTATUS_LOADED:

		m11RPGwj_loadPlayerStatus(m11RPGwj_resManager.getItem("playerstatus.dat").item);

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_IMAGE;

		break;

	// 画像読み込みを開始
	case m11RPGwj_SystemStatus.LOADINGSTATE_IMAGE:

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_IMAGE_LOADING;

		for (i = 0;i < m11RPGwj_config.resourceImageNameList.length;i++) {
			m11RPGwj_resManager.loadImage(m11RPGwj_config.resourceImageNameList[i], m11RPGwj_resourceImageLoaded);
		}

		break;

	// 読み込んだ画像を変数に設定
	case m11RPGwj_SystemStatus.LOADINGSTATE_IMAGE_LOADED:

		m11RPGwj_data.chipImage = m11RPGwj_resManager.getItem(m11RPGwj_config.chipImage).item;
		m11RPGwj_data.charImage = m11RPGwj_resManager.getItem(m11RPGwj_config.charImage).item;

		var img;

		for (img in m11RPGwj_data.enemyImageList) {
			m11RPGwj_data.enemyImageList[img] = m11RPGwj_resManager.getItem(img).item;
		}

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_START;

		break;

	// 開始時情報読み込みを開始
	case m11RPGwj_SystemStatus.LOADINGSTATE_START:

		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_START_LOADING;

		m11RPGwj_resManager.loadText("start.dat", function() { m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_START_LOADED; });

		break;

	// 読み込んだ開始時情報を設定
	case m11RPGwj_SystemStatus.LOADINGSTATE_START_LOADED:

		items = m11RPGwj_resManager.getItem("start.dat").item.split("\t");

		m11RPGwj_playerStatus.map = m11RPGwj_data.getMapIndex(parseInt(items[0]));

		// 開始位置設定
		m11RPGwj_playerStatus.x = parseInt(items[1]);
		m11RPGwj_playerStatus.y = parseInt(items[2]);

		m11RPGwj_systemStatus.v_x = m11RPGwj_playerStatus.x;
		m11RPGwj_systemStatus.v_y = m11RPGwj_playerStatus.y;

		// 開始時イベントスクリプト設定
		m11RPGwj_config.start_event = parseInt(items[3]);

		// 主人公名設定
		m11RPGwj_playerStatus.status.name = items[4];

		// 主人公キャラクタ
		m11RPGwj_playerStatus.char_no = parseInt(items[5]);

		if (m11RPGwj_config.title_image == null) {

			m11RPGwj_systemStatus.app_status = m11RPGwj_SystemStatus.APPSTATE_START;
			m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.STARTSTATE_INIT;

		} else {

			m11RPGwj_systemStatus.app_status = m11RPGwj_SystemStatus.APPSTATE_TITLE;
			m11RPGwj_systemStatus.process_status = 0;

		}

		break;

	}

}

function m11RPGwj_loadConfig(data) {

	var i;

	// 改行を\nに統一
	data = data.replace("\r\n", "\n");
	data = data.replace("\r", "\n");

	// 行ごとに配列に切り分ける
	var dataLineList = data.split("\n");

	var lineItems;

	m11RPGwj_config.gameID = null;
	m11RPGwj_config.gameVer = null;
	m11RPGwj_config.saveVer = null;

	m11RPGwj_config.title_image = null;
	m11RPGwj_config.title_music = null;
	m11RPGwj_config.end_image = null;
	m11RPGwj_config.end_music = null;

	// データ文字列の各行を読み取り
	for (i = 0;i < dataLineList.length;i++) {

		if (dataLineList[i].charCodeAt(dataLineList[i].length - 1) == 13) {
			dataLineList[i] = dataLineList[i].slice(0, -1);
		}

		// 「=」区切りを分離し個々の設定項目を取得
		lineItems = dataLineList[i].split("=");

		if (lineItems.length == 2) {

			switch (lineItems[0]) {

			case 'gameID':

				m11RPGwj_config.gameID = lineItems[1];

				break;

			case 'gameVer':

				m11RPGwj_config.gameVer = lineItems[1];

				break;

			case 'saveVer':

				m11RPGwj_config.saveVer = lineItems[1];

				break;

			case 'chipWidth':

				m11RPGwj_config.chip_width = parseInt(lineItems[1]);

				break;

			case 'chipHeight':

				m11RPGwj_config.chip_height = parseInt(lineItems[1]);

				break;

			case 'chipImage':

				m11RPGwj_config.chipImage = lineItems[1];

				break;

			case 'charImage':

				m11RPGwj_config.charImage = lineItems[1];

				break;

			case 'viewCols':

				m11RPGwj_config.view_cols = parseInt(lineItems[1]);

				break;

			case 'viewRows':

				m11RPGwj_config.view_rows = parseInt(lineItems[1]);

				break;

			case 'bgColor':

				m11RPGwj_config.bg_color = lineItems[1];

				break;

			case 'titleImage':

				m11RPGwj_config.title_image = lineItems[1];

				break;

			case 'titleMusic':

				m11RPGwj_config.title_music = lineItems[1];

				break;

			}

		}

	}

}

function m11RPGwj_loadMapList(data) {

	var i;
	var item;

	// 改行を\nに統一
	data = data.replace("\r\n", "\n");
	data = data.replace("\r", "\n");

	// 行ごとに配列に切り分ける
	var dataLineList = data.split("\n");

	m11RPGwj_loadDataList = new Array();

	// データ文字列の各行を読み取り
	for (i = 0;i < dataLineList.length;i++) {

		// TSV各要素を分離し、マップ情報を取得
		lineItems = dataLineList[i].split("\t");

		if (lineItems != null && lineItems.length == 5) {

			item = new m11RPGwj_Map();

			item.no = parseInt(lineItems[0]);

			item.cols = parseInt(lineItems[1]);
			item.rows = parseInt(lineItems[2]);

			item.chipMap = lineItems[3];
			item.eventMap = lineItems[4];

			m11RPGwj_data.mapList.push(item);

			if (!m11RPGwj_hasItem(m11RPGwj_loadDataList, lineItems[3])) {
				m11RPGwj_loadDataList.push(lineItems[3]);
			}

			if (!m11RPGwj_hasItem(m11RPGwj_loadDataList, lineItems[4])) {
				m11RPGwj_loadDataList.push(lineItems[4]);
			}

		}

	}

}

// イベント配置情報を設定
function m11RPGwj_loadMapData() {

	var i, j, k;

	var processed = 0;

	for (i = 0;i < m11RPGwj_loadDataList.length;i++) {

		var item = m11RPGwj_resManager.getItem(m11RPGwj_loadDataList[i]);

		if (item && item.item.length > 0) {

			item = item.item;

			for (j = 0;j < m11RPGwj_data.mapList.length;j++) {

				if (m11RPGwj_data.mapList[j].chipMap == m11RPGwj_loadDataList[i]) {

					m11RPGwj_data.mapList[j].chipMap = new Array();

					for (k = 0;k < item.length;k++) {

						var c = item.charCodeAt(k);

						if (c >= '0'.charCodeAt(0) && c <= '9'.charCodeAt(0)) {
							m11RPGwj_data.mapList[j].chipMap.push(c - '0'.charCodeAt(0));
						}

						if (c >= 'a'.charCodeAt(0) && c <= 'z'.charCodeAt(0)) {
							m11RPGwj_data.mapList[j].chipMap.push(c - 'a'.charCodeAt(0) + 10);
						}

						if (item.charAt(k) >= 'A' && item.charAt(k) <= 'Z') {
							m11RPGwj_data.mapList[j].chipMap.push(c - 'A'.charCodeAt(0) + 36);
						}

						if (item.charAt(k) == '-') {
							m11RPGwj_data.mapList[j].chipMap.push(62);
						}

						if (item.charAt(k) == '=') {
							m11RPGwj_data.mapList[j].chipMap.push(63);
						}

					}

				}

				if (m11RPGwj_data.mapList[j].eventMap == m11RPGwj_loadDataList[i]) {

					m11RPGwj_data.mapList[j].eventMap = new Array();

					for (k = 0;k < item.length;k++) {

						var c = item.charCodeAt(k);

						if (c >= '0'.charCodeAt(0) && c <= '9'.charCodeAt(0)) {
							m11RPGwj_data.mapList[j].eventMap.push(c - '0'.charCodeAt(0));
						}

						if (c >= 'a'.charCodeAt(0) && c <= 'z'.charCodeAt(0)) {
							m11RPGwj_data.mapList[j].eventMap.push(c - 'a'.charCodeAt(0) + 10);
						}

						if (item.charAt(k) >= 'A' && item.charAt(k) <= 'Z') {
							m11RPGwj_data.mapList[j].eventMap.push(item.charAt(k) - 'a' + 36);
						}

						if (item.charAt(k) == '-') {
							m11RPGwj_data.mapList[j].eventMap.push(62);
						}

						if (item.charAt(k) == '=') {
							m11RPGwj_data.mapList[j].eventMap.push(63);
						}

						if (item.charAt(k) == '?') {
							m11RPGwj_data.mapList[j].eventMap.push(-1);
						}

					}

				}

			}

			m11RPGwj_loadDataList[i] = null;

		}

		if (m11RPGwj_loadDataList[i] == null) {
			processed++;
		}

	}

	if (processed == m11RPGwj_loadDataList.length) {
		m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_MAPDATA_LOADED;
	}

}

// イベントテーブル設定
function m11RPGwj_loadEvent(data) {

	var itemList = new Array();
	var item;

	var itemHeader;
	var condList;

	// 改行を\nに統一
	data = data.replace("\r\n", "\n");
	data = data.replace("\r", "\n");

	var dataLineList = data.split("\n");

	var status = 0;

	for (i = 0;i < dataLineList.length;i++) {

		switch (status) {

		// 新たなイベントデータ検索のため走査中
		case 0:

			// 行頭に<が出てきたら、イベントデータとして認識
			if (dataLineList[i].length > 0 && dataLineList[i].indexOf("<") == 0) {

				// タブ区切りでイベント属性を認識
				itemHeader = dataLineList[i].substr(1).split("\t");

				item = new Object();

				// 最初の要素を16進数字のイベント番号として取得
				item.no = parseInt(itemHeader[0]);

				// イベント発動条件を取得
				if (itemHeader[1].length > 0) {

					condList = itemHeader[1].split(":");

					item.cond = new Array();

					item.cond[0] = parseInt(condList[0]);
					item.cond[1] = parseInt(condList[1]);

				} else {
					item.cond = null;
				}

				item.type = parseInt(itemHeader[2]);
				item.chr = parseInt(itemHeader[3]);
				item.script = '';

				// イベントデータ走査中状態に
				status = 1;

			}

			break;

		// イベントデータ走査中
		case 1:

			if (dataLineList[i].length > 0) {

				// 行頭に>が出てきたら、イベントデータ終了
				if (dataLineList[i].indexOf(">") == 0) {

					// これまでに読み込んだデータからイベントを作成し登録
					m11RPGwj_data.eventList[item.no] = new m11RPGwj_EventItem(item.cond, item.type, item.chr, item.script);

					// イベントデータ検索状態に
					status = 0;

				} else {

					// 現在の行をイベントスクリプトに追加
					item.script = item.script + dataLineList[i] + "\n";

				}
			}

			break;

		}

	}

}





// 敵テーブル設定
function m11RPGwj_loadEnemy(data) {

	var itemList = new Array();
	var item;

	var itemFields;

	// 改行を\nに統一
	data = data.replace("\r\n", "\n");
	data = data.replace("\r", "\n");

	var dataLineList = data.split("\n");

	var status = 0;

	for (i = 0;i < dataLineList.length;i++) {

		switch (status) {

		// 新たな敵データ検索のため走査中
		case 0:

			// 行頭に<が出てきたら、敵データとして認識
			if (dataLineList[i].length > 0 && dataLineList[i].indexOf("<") == 0) {

				// タブ区切りでイベント属性を認識
				itemFields = dataLineList[i].substr(1).split("\t");

				no = parseInt(itemFields[0]);

				item = new Object();

				item.no = no;

				item.name = itemFields[1];
				item.hp = parseInt(itemFields[2]);
				item.mhp = parseInt(itemFields[3]);
				item.mp = parseInt(itemFields[4]);
				item.mmp = parseInt(itemFields[5]);
				item.at = parseInt(itemFields[6]);
				item.def = parseInt(itemFields[7]);
				item.mf = parseInt(itemFields[8]);
				item.exp = parseInt(itemFields[9]);
				item.image = trim(itemFields[10]);

				m11RPGwj_data.enemyImageList[item.image] = null;
				m11RPGwj_config.resourceImageNameList.push(item.image);

				item.scriptList = new Array();

				// イベントデータ走査中状態に
				status = 1;

			}

			break;

		// イベントデータ走査中
		case 1:

			if (dataLineList[i].length > 0) {

				// 行頭に>が出てきたら、データ終了
				if (dataLineList[i].indexOf(">") == 0) {

					m11RPGwj_data.enemyList[item.no] = item;

					// イベントデータ検索状態に
					status = 0;

				} else {

					// 現在の行をイベントスクリプトに追加
					item.scriptList.push(m11RPGwj_parseFunction(dataLineList[i]));

				}
			}

			break;

		}

	}

}

// 道具情報を設定
function m11RPGwj_loadItemList(data) {

	var i;

	// 改行を\nに統一
	data = data.replace("\r\n", "\n");
	data = data.replace("\r", "\n");

	var dataLineList = data.split("\n");
	var itemFields;

	var no;

	for (i = 0;i < dataLineList.length;i++) {

		itemFields = dataLineList[i].split("\t");

		no = parseInt(itemFields[0]);

		if (no >= 0 && no <= 7) {

			m11RPGwj_data.playerItemList[no] = new m11RPGwj_PlayerItem(null);

			m11RPGwj_data.playerItemList[no].no = no;
			m11RPGwj_data.playerItemList[no].name = itemFields[1];

			m11RPGwj_data.playerItemList[no].type = parseInt(itemFields[2]);

			if (itemFields[3] == null || itemFields[3].length < 1) {
				m11RPGwj_data.playerItemList[no].field_effect = null;
			} else {
				m11RPGwj_data.playerItemList[no].field_effect = itemFields[3];
			}

			if (itemFields[4] == null || itemFields[4].length < 1) {
				m11RPGwj_data.playerItemList[no].field_message = null;
			} else {
				m11RPGwj_data.playerItemList[no].field_message = itemFields[4];
			}

			if (itemFields[5] == null || itemFields[5].length < 1) {
				m11RPGwj_data.playerItemList[no].battle_effect = null;
			} else {
				m11RPGwj_data.playerItemList[no].battle_effect = itemFields[5];
			}

			if (itemFields[6] == null || itemFields[6].length < 1) {
				m11RPGwj_data.playerItemList[no].battle_message = null;
			} else {
				m11RPGwj_data.playerItemList[no].battle_message = itemFields[6];
			}

			if (itemFields[7] == null || itemFields[7].length < 1) {
				m11RPGwj_data.playerItemList[no].equip_effect = null;
			} else {
				m11RPGwj_data.playerItemList[no].equip_effect = itemFields[7];
			}

			m11RPGwj_data.playerItemList[no].useNum = parseInt(itemFields[8]);

		}

	}

}

// 魔法一覧を設定
function m11RPGwj_loadMagicList(data) {

	var i;

	// 改行を\nに統一
	data = data.replace("\r\n", "\n");
	data = data.replace("\r", "\n");

	var dataLineList = data.split("\n");

	m11RPGwj_data.magicList = new Array();

	for (i = 0;i < dataLineList.length;i++) {

		var itemList = dataLineList[i].split("\t");

		if (itemList.length == 8) {

			var item = new m11RPGwj_Magic();

			item.no = itemList[0];
			item.name = itemList[1];
			item.mp = itemList[2];
			item.player_effect_type = itemList[3];
			item.player_effect = itemList[4];
			item.enemy_effect_type = itemList[5];
			item.enemy_effect = itemList[6];
			item.cond = itemList[7];

			m11RPGwj_data.magicList.push(item);

		}

	}

}

// 主人公ステータス情報を設定
function m11RPGwj_loadPlayerStatus(data) {

	var i;

	// 改行を\nに統一
	data = data.replace("\r\n", "\n");
	data = data.replace("\r", "\n");

	var dataLineList = data.split("\n");

	for (i = 0;i < dataLineList.length;i++) {

		var itemList = dataLineList[i].split(":");

		switch (itemList[0]) {

		case "mhp_base":

			m11RPGwj_data.scriptFormula.player_mhp_base = trim(itemList[1]);

			break;

		case "mmp_base":

			m11RPGwj_data.scriptFormula.player_mmp_base = trim(itemList[1]);

			break;

		case "at_base":

			m11RPGwj_data.scriptFormula.player_at_base = trim(itemList[1]);

			break;

		case "def_base":

			m11RPGwj_data.scriptFormula.player_def_base = trim(itemList[1]);

			break;

		case "mf_base":

			m11RPGwj_data.scriptFormula.player_mf_base = trim(itemList[1]);

			break;

		case "battle_player_attack":

			m11RPGwj_data.scriptFormula.battle_player_attack = trim(itemList[1]);

			break;

		case "battle_enemy_attack":

			m11RPGwj_data.scriptFormula.battle_enemy_attack = trim(itemList[1]);

			break;

		}

	}

}

// リソースマネージャーによる画像読み込み完了時のイベントハンドラ
function m11RPGwj_resourceImageLoaded() {

	var i;

	// 読み込んでいない画像があれば読み込み状態継続
	for (i = 0;i < m11RPGwj_config.resourceImageNameList.length;i++) {
		if (!m11RPGwj_resManager.isLoaded(m11RPGwj_config.resourceImageNameList[i])) {
			return;
		}
	}

	// 画像読み込み完了状態へ
	m11RPGwj_systemStatus.loading_status = m11RPGwj_SystemStatus.LOADINGSTATE_IMAGE_LOADED;

}

// 通常（マップ上移動）状態時の処理
function m11RPGwj_walk() {

	switch (m11RPGwj_systemStatus.scroll_state) {

	// 非スクロール時
	case 0:

		if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_SELECT) {

			m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.GMAESTATE_COMMAND;
			m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_INIT;

			break;

		}

		switch (m11RPGwj_systemStatus.controller.getStick()) {

		// 上キー押下
		case m11RPGwj_Controller.KEYFLAG_UP:

			if (m11RPGwj_touch(m11RPGwj_playerStatus.x, m11RPGwj_playerStatus.y - 1)) {

				// スクロール方向設定
				m11RPGwj_systemStatus.scroll_dir = m11RPGwj_Controller.KEYFLAG_UP;
				m11RPGwj_systemStatus.dx = 0;
				m11RPGwj_systemStatus.dy = -1;

				// 初期描画ずらし量
				m11RPGwj_systemStatus.sx = 0;
				m11RPGwj_systemStatus.sy = -m11RPGwj_config.chip_height;

				// マップ内描画開始位置
				m11RPGwj_systemStatus.v_x = m11RPGwj_playerStatus.x;
				m11RPGwj_systemStatus.v_y = m11RPGwj_playerStatus.y - 1;

				// 描画範囲
				m11RPGwj_systemStatus.v_cols = m11RPGwj_config.view_cols;
				m11RPGwj_systemStatus.v_rows = m11RPGwj_config.view_rows + 1;

				// スクロール中フラグ設定
				m11RPGwj_systemStatus.scroll_state = 1;

			}

			break;

		// 下キー押下
		case m11RPGwj_Controller.KEYFLAG_DOWN:

			if (m11RPGwj_touch(m11RPGwj_playerStatus.x, m11RPGwj_playerStatus.y + 1)) {

				// スクロール方向設定
				m11RPGwj_systemStatus.scroll_dir = m11RPGwj_Controller.KEYFLAG_DOWN;
				m11RPGwj_systemStatus.dx = 0;
				m11RPGwj_systemStatus.dy = 1;

				// 初期描画ずらし量
				m11RPGwj_systemStatus.sx = 0;
				m11RPGwj_systemStatus.sy = 0;

				// マップ内描画開始位置
				m11RPGwj_systemStatus.v_x = m11RPGwj_playerStatus.x;
				m11RPGwj_systemStatus.v_y = m11RPGwj_playerStatus.y;

				// 描画範囲
				m11RPGwj_systemStatus.v_cols = m11RPGwj_config.view_cols;
				m11RPGwj_systemStatus.v_rows = m11RPGwj_config.view_rows + 1;

				// スクロール中フラグ設定
				m11RPGwj_systemStatus.scroll_state = 1;

			}

			break;

		// 左キー押下
		case m11RPGwj_Controller.KEYFLAG_LEFT:

			if (m11RPGwj_touch(m11RPGwj_playerStatus.x - 1, m11RPGwj_playerStatus.y)) {

				// スクロール方向設定
				m11RPGwj_systemStatus.scroll_dir = m11RPGwj_Controller.KEYFLAG_LEFT;
				m11RPGwj_systemStatus.dx = -1;
				m11RPGwj_systemStatus.dy = 0;

				// 初期描画ずらし量
				m11RPGwj_systemStatus.sx = -m11RPGwj_config.chip_width;
				m11RPGwj_systemStatus.sy = 0;

				// マップ内描画開始位置
				m11RPGwj_systemStatus.v_x = m11RPGwj_playerStatus.x - 1;
				m11RPGwj_systemStatus.v_y = m11RPGwj_playerStatus.y;

				// 描画範囲
				m11RPGwj_systemStatus.v_cols = m11RPGwj_config.view_cols + 1;
				m11RPGwj_systemStatus.v_rows = m11RPGwj_config.view_rows;

				// スクロール中フラグ設定
				m11RPGwj_systemStatus.scroll_state = 1;

			}

			break;

		// 右キー押下
		case m11RPGwj_Controller.KEYFLAG_RIGHT:

			if (m11RPGwj_touch(m11RPGwj_playerStatus.x + 1, m11RPGwj_playerStatus.y)) {

				// スクロール方向設定
				m11RPGwj_systemStatus.scroll_dir = m11RPGwj_Controller.KEYFLAG_RIGHT;
				m11RPGwj_systemStatus.dx = 1;
				m11RPGwj_systemStatus.dy = 0;

				// 初期描画ずらし量
				m11RPGwj_systemStatus.sx = 0;
				m11RPGwj_systemStatus.sy = 0;

				// マップ内描画開始位置
				m11RPGwj_systemStatus.v_x = m11RPGwj_playerStatus.x;
				m11RPGwj_systemStatus.v_y = m11RPGwj_playerStatus.y;

				// 描画範囲
				m11RPGwj_systemStatus.v_cols = m11RPGwj_config.view_cols + 1;
				m11RPGwj_systemStatus.v_rows = m11RPGwj_config.view_rows;

				// スクロール中フラグ設定
				m11RPGwj_systemStatus.scroll_state = 1;

			}

			break;

		}

		break;

	// スクロール中
	case 1:

		// スクロール位置を更新
		m11RPGwj_systemStatus.scroll_pos += m11RPGwj_systemStatus.scroll_pixel;

		// スクロール位置がチップサイズに達したら、スクロール終了
		if ((((m11RPGwj_systemStatus.scroll_dir == m11RPGwj_Controller.KEYFLAG_UP) || (m11RPGwj_systemStatus.scroll_dir == m11RPGwj_Controller.KEYFLAG_DOWN)) && m11RPGwj_systemStatus.scroll_pos == m11RPGwj_config.chip_height) || (((m11RPGwj_systemStatus.scroll_dir == m11RPGwj_Controller.KEYFLAG_LEFT) || (m11RPGwj_systemStatus.scroll_dir == m11RPGwj_Controller.KEYFLAG_RIGHT)) && m11RPGwj_systemStatus.scroll_pos == m11RPGwj_config.chip_width)) {

			// 現在位置更新
			m11RPGwj_playerStatus.x += m11RPGwj_systemStatus.dx;
			m11RPGwj_playerStatus.y += m11RPGwj_systemStatus.dy;

			m11RPGwj_systemStatus.dx = 0;
			m11RPGwj_systemStatus.dy = 0;

			m11RPGwj_systemStatus.sx = 0;
			m11RPGwj_systemStatus.sy = 0;

			m11RPGwj_systemStatus.v_x = m11RPGwj_playerStatus.x;
			m11RPGwj_systemStatus.v_y = m11RPGwj_playerStatus.y;

			m11RPGwj_systemStatus.v_cols = m11RPGwj_config.view_cols;
			m11RPGwj_systemStatus.v_rows = m11RPGwj_config.view_rows;

			m11RPGwj_systemStatus.scroll_pos = 0;
			m11RPGwj_systemStatus.scroll_state = 0;

			// 進入時の処理
			m11RPGwj_enter(m11RPGwj_playerStatus.x, m11RPGwj_playerStatus.y);

			// 直ちに次のprocess呼び出しへ
			return true;

		}

		break;

	}

	return false;

}

// 接触時処理
function m11RPGwj_touch(tx, ty) {

	// 地形チップ番号が16未満なら進入不可
	if (m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].chipMap[tx + ty * m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].cols] < 16) {
		return false;
	}

	var ev = null;

	// 指定位置のイベント情報オブジェクトを取得
	if (m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].eventMap[tx + ty * m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].cols] >= 0) {
		ev = m11RPGwj_data.eventList[m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].eventMap[tx + ty * m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].cols]];
	}

	// 接触発動タイプの有効イベントがあればイベント処理状態へ
	if (ev != null && ev.type == 0 && (ev.cond == null || m11RPGwj_playerStatus.varList[ev.cond[0]] == ev.cond[1])) {

		m11RPGwj_systemStatus.scriptContext = m11RPGwj_ScriptContext.createScriptContext(ev.scriptList, null);

		// スクリプト処理中状態へ移行
		m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.GMAESTATE_SCRIPT;

		return false;

	}

	return true;

}

// 進入時の処理
function m11RPGwj_enter(ex, ey) {

	var ev = null;

	// 指定位置のイベント情報オブジェクトを取得
	if (m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].eventMap[ex + ey * m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].cols] >= 0) {
		ev = m11RPGwj_data.eventList[m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].eventMap[ex + ey * m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].cols]];
	}

	// 進入発動タイプの有効イベントがあればイベントへ
	if (ev != null && ev.type == 1 && (ev.cond == null || m11RPGwj_playerStatus.varList[ev.cond[0]] == ev.cond[1])) {

		m11RPGwj_systemStatus.scriptContext = m11RPGwj_ScriptContext.createScriptContext(ev.scriptList, null);

		// スクリプト処理中状態へ移行
		m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.GMAESTATE_SCRIPT;

		return false;

	}

	return true;

}

function m11RPGwj_script(context) {

	var i;
	var dmg;
	var msg;
	var itemEventList;
	var item;

	switch (context.status) {

	// 次に実行するコードを読み込み実行開始
	case m11RPGwj_ScriptContext.SCRIPTSTATE_CODELOAD:

		// if()なら条件判定を行って分岐処理
		if (context.list[context.pos].name == "if") {

			// 条件が成立しなければendif()まで読み飛ばす
			if (!m11RPGwj_getBoolValue(context.list[context.pos].args[0], context)) {

				// if()深さカウンタ設定
				context.if_level++;

				// 現在のif()が終わるかelse文までループ
				while (context.if_level > 0) {

					context.pos++;

					// if()が出てきたら深さ加算
					if (context.list[context.pos].name == "if") {
						context.if_level++;
					}

					// endif()が出てきたら深さ減算
					if (context.list[context.pos].name == "endif") {
						context.if_level--;
					}

					// if()直下にelseが出てきたら終了
					if (context.if_level == 1 && context.list[context.pos].name == "else") {
						context.if_level = 0;
					}

				}

			}

		} else {

			// elseなら対応するendifまで移動
			if (context.list[context.pos].name == "else") {

				// if()深さカウンタ設定
				context.if_level++;

				// 現在のif()が終わるかelse文までループ
				while (context.if_level > 0) {

					context.pos++;

					// if()が出てきたら深さ加算
					if (context.list[context.pos].name == "if") {
						context.if_level++;
					}

					// endif()が出てきたら深さ減算
					if (context.list[context.pos].name == "endif") {
						context.if_level--;
					}

				}

			}

		}

		if (context.pos >= context.list.length) {
			return m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTEXIT;
		} else {
			// 現在位置のスクリプトを実行
			m11RPGwj_execFunction(context.list[context.pos], context);
		}

		// m11RPGwj_script()呼び出し継続
		return m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTEXEC;

	// コード実行中
	case m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXEC:

		switch (context.list[context.pos].name.toString()) {

		// move()による移動後の処理
		case "move":

			switch (context.stage) {

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MOVE_BLACKOUT_IN:

				if (++m11RPGwj_systemStatus.move_count == 6) {

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MOVE_BLACKOUT;

					m11RPGwj_playerStatus.map = m11RPGwj_systemStatus.move_pos.map;

					m11RPGwj_playerStatus.x = m11RPGwj_systemStatus.move_pos.x;
					m11RPGwj_playerStatus.y = m11RPGwj_systemStatus.move_pos.y;

					m11RPGwj_systemStatus.v_x = m11RPGwj_playerStatus.x;
					m11RPGwj_systemStatus.v_y = m11RPGwj_playerStatus.y;

				}

				break;

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MOVE_BLACKOUT:

				if (++m11RPGwj_systemStatus.move_count == 12) {

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MOVE_BLACKOUT_OUT;

					if (m11RPGwj_systemStatus.loading_audio != null) {

						m11RPGwj_soundMenuSync();

						m11RPGwj_setBGM(m11RPGwj_systemStatus.loading_audio);

					}

				}

				break;

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MOVE_BLACKOUT_OUT:

				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
				m11RPGwj_systemStatus.scriptContext.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_NONE;

				m11RPGwj_systemStatus.move_count = 0;

				break;

			}

			break;

		// message()によるメッセージ表示ウインドウ表示中
		case "message":

			switch (context.stage) {

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MESSAGE_VIEW:

				// ユーザーによる操作が終わったらmessage()終了状態へ
				if (m11RPGwj_systemStatus.scriptMeswin.process(m11RPGwj_systemStatus.controller)) {

					m11RPGwj_systemStatus.scriptMeswin.hide();

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MESSAGE_EXIT;

				}

				break;

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MESSAGE_EXIT:

				// リターンキー解放を待ってメッセージ表示状態終了
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {
					context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
				}

				break;

			}

			break;

		// select()による選択ダイアログ表示中
		case "select":

			// ユーザーによる操作が終わったらselect()終了状態へ
			if (m11RPGwj_systemStatus.scriptSelectDlg.process(m11RPGwj_systemStatus.controller)) {

				i = m11RPGwj_getValue(context.list[context.pos].args[0], context);

				if (i >= 0 && i < context.localVar.length) {
					context.localVar[i] = m11RPGwj_systemStatus.scriptSelectDlg.getIndex();
				}

				m11RPGwj_systemStatus.scriptSelectDlg.hide();

				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;

			}

			break;

		// playVideo()による動画再生
		case "playVideo":

			switch (context.stage) {

			// 画像読み込み完了
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_LOADED:

				// リターンキー解放を待って表示開始
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					m11RPGwj_systemStatus.videoPlayer.style.visibility = 'visible';

					m11RPGwj_systemStatus.videoPlayer.style.left = (m11RPGwj_config.view_center_x - (m11RPGwj_systemStatus.videoPlayer.videoWidth / 2)) + 'px';
					m11RPGwj_systemStatus.videoPlayer.style.top = (m11RPGwj_config.view_center_y - (m11RPGwj_systemStatus.videoPlayer.videoHeight / 2)) + 'px';

					m11RPGwj_soundMenuSync();

					m11RPGwj_systemStatus.videoPlayer.play();

					// 画像表示状態へ
					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_VIEW;

				}

				break;

			// 動画表示中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_VIEW:

				// リターンキーが押されたら表示終了待機状態へ
				if (m11RPGwj_systemStatus.controller.getButtons() != m11RPGwj_Controller.KEYFLAG_NONE) {
					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_EXIT;
				}

				break;

			// 表示終了待機状態
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_EXIT:

				// リターンキー解放でimage()終了
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_NONE;

					m11RPGwj_systemStatus.videoPlayer.pause();
					m11RPGwj_systemStatus.videoPlayer.src = '';

					// 動画再生要素を隠す
					m11RPGwj_systemStatus.videoPlayer.style.visibility = 'hidden';

				}

				break;

			}

		// image()による画像表示
		case "image":

			switch (context.stage) {

			// 画像読み込み完了
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_LOADED:

				// リターンキー解放を待って表示開始
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					m11RPGwj_systemStatus.loaded_image = m11RPGwj_systemStatus.loading_image;
					m11RPGwj_systemStatus.loading_image = null;

					// 画像表示状態へ
					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_VIEW;

				}

				break;

			// 画像表示中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_VIEW:

				// リターンキーが押されたら表示終了待機状態へ
				if (m11RPGwj_systemStatus.controller.getButtons() != m11RPGwj_Controller.KEYFLAG_NONE) {
					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_EXIT;
				}

				break;

			// 表示終了待機状態
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_EXIT:

				// リターンキー解放でimage()終了
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_NONE;

					delete m11RPGwj_systemStatus.loaded_image;
					m11RPGwj_systemStatus.loaded_image = null;

				}

				break;

			}

			break;

		// 画面フラッシュ処理中
		case "flash":

			// 現在の処理状態に応じた処理を実行
			switch (context.stage) {

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_FLASH_IN:

				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_FLASH;

				// 一時的に描画速度を上げる
				m11RPGwj_systemStatus.frame_ms = 20;

				break;

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_FLASH:

				if (++m11RPGwj_systemStatus.flash_count == 16) {
					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_FLASH_OUT;
				}

				break;

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_FLASH_OUT:

				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;

				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_NONE;

				// 描画速度を戻す
				m11RPGwj_systemStatus.frame_ms = m11RPGwj_systemStatus.frame_ms = m11RPGwj_config.default_frame_ms;

				m11RPGwj_systemStatus.bg_color = '#' + m11RPGwj_config.bg_color;

				// canvasの背景色を設定
				m11RPGwj_systemStatus.viewCanvas.style.background = m11RPGwj_systemStatus.bg_color;

				m11RPGwj_systemStatus.flash_count = 0;

				break;

			}

			break;

		// battle()による戦闘処理中
		case "battle":

			// 現在の処理状態に応じた処理を実行
			switch (context.stage) {

			// 戦闘開始メッセージ表示中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_START:

				// メッセージ表示が終わったら次へ
				if (m11RPGwj_systemStatus.scriptMeswin.process(m11RPGwj_systemStatus.controller)) {
					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_COMMAND_IN;
				}

				break;

			// 戦闘コマンド表示待機中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_COMMAND_IN:

				// リターンキー解放を確認したら戦闘コマンド表示へ
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_COMMAND;

					m11RPGwj_systemStatus.scriptSelectDlg.reset();

					m11RPGwj_systemStatus.scriptSelectDlg.show();
					m11RPGwj_systemStatus.scriptMeswin.show();

				}

				break;

			// 戦闘コマンド選択中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_COMMAND:

				// コマンドが選択されたら次へ
				if (m11RPGwj_systemStatus.scriptSelectDlg.process(m11RPGwj_systemStatus.controller)) {

					m11RPGwj_systemStatus.scriptSelectDlg.hide();

					// 選択結果に応じて状態分岐
					switch (m11RPGwj_systemStatus.scriptSelectDlg.getIndex()) {

					// 戦う
					case 0:

						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_PLAYERATTACK_IN;

						break;

					// 道具
					case 1:

						m11RPGwj_systemStatus.itemDlg.setup(m11RPGwj_playerStatus.itemHolder, m11RPGwj_systemStatus.viewContext);

						winx = (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) / 2;
						winy = (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) / 2;

						m11RPGwj_systemStatus.itemDlg.setPos(winx, winy);

						m11RPGwj_systemStatus.itemDlg.reset();
						m11RPGwj_systemStatus.itemDlg.show();

						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ITEMMENU;

						break;

					// 魔法
					case 2:

						m11RPGwj_playerStatus.magicList = new Array();

						list = new Array();
						list.push("戻る");

						for (i = 0;i < m11RPGwj_data.magicList.length;i++) {
							if (m11RPGwj_getBoolValue(m11RPGwj_data.magicList[i].cond, null)) {

								m11RPGwj_playerStatus.magicList.push(m11RPGwj_data.magicList[i]);
								list.push(m11RPGwj_data.magicList[i].name);

							}
						}

						m11RPGwj_systemStatus.magicDlg.reset();

						m11RPGwj_systemStatus.magicDlg.setItems(list, m11RPGwj_systemStatus.viewContext);
						m11RPGwj_systemStatus.magicDlg.setCancelable(true);

						winx = ((m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) - m11RPGwj_systemStatus.magicDlg.getWidth()) / 2;
						winy = ((m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) - m11RPGwj_systemStatus.magicDlg.getHeight()) / 2;

						m11RPGwj_systemStatus.magicDlg.setPos(winx, winy);

						m11RPGwj_systemStatus.magicDlg.show();

						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_MAGICMENU;

						break;

					// 逃げる
					case 3:

						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ESCAPE_IN;

						break;

					}

				}

				break;

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ITEMMENU:

				if (m11RPGwj_systemStatus.itemDlg.process(m11RPGwj_systemStatus.controller)) {

					if (m11RPGwj_systemStatus.itemDlg.resultItem == null) {
						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_COMMAND_IN;
					} else {
						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ITEMMENU_DONE;
					}

				}

				break;

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ITEMMENU_DONE:

				// リターンキー解放を待って終了処理
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					switch (m11RPGwj_systemStatus.itemDlg.result) {

					// 道具使用
					case m11RPGwj_ItemDialog.RESULT_USE:

						itemEventList = new Array();

						if (m11RPGwj_systemStatus.itemDlg.resultItem.battle_message == null) {
							itemEventList.push(m11RPGwj_parseFunction('message("' + m11RPGwj_systemStatus.itemDlg.resultItem.name + 'を使った")'));
						} else {
							itemEventList.push(m11RPGwj_parseFunction('message("' + m11RPGwj_systemStatus.itemDlg.resultItem.battle_message + '")'));
						}

						if (m11RPGwj_systemStatus.itemDlg.resultItem.battle_effect != null && m11RPGwj_systemStatus.itemDlg.resultItem.battle_effect.length > 0) {
							itemEventList.push(m11RPGwj_parseFunction(m11RPGwj_systemStatus.itemDlg.resultItem.battle_effect));
						}

						// 使用回数制限があれば使用可能回数を減らす
						if (m11RPGwj_systemStatus.itemDlg.resultItem.useNum > 0) {

							// 使用可能回数を1減らす
							m11RPGwj_systemStatus.itemDlg.resultItem.useNum--;

							// 使用可能回数が0になったらアイテム削除
							if (m11RPGwj_systemStatus.itemDlg.resultItem.useNum == 0) {
								m11RPGwj_playerStatus.itemHolder.deleteItem(m11RPGwj_systemStatus.itemDlg.resultItem);
							}

						}

						break;

					// 道具装備
					case m11RPGwj_ItemDialog.RESULT_EQUIP:

						itemEventList = new Array();

						if (m11RPGwj_systemStatus.itemDlg.resultItem.equip) {
							itemEventList.push(m11RPGwj_parseFunction('message("' + m11RPGwj_systemStatus.itemDlg.resultItem.name + 'を外した")'));
						} else {
							itemEventList.push(m11RPGwj_parseFunction('message("' + m11RPGwj_systemStatus.itemDlg.resultItem.name + 'を装備した")'));
						}

						// 装備状態設定
						m11RPGwj_playerStatus.itemHolder.setEquip(m11RPGwj_systemStatus.itemDlg.resultItem, !m11RPGwj_systemStatus.itemDlg.resultItem.equip);

						m11RPGwj_updateStatus();

						break;

					// 道具捨てる
					case m11RPGwj_ItemDialog.RESULT_DISPOSE:

						itemEventList = new Array();

						itemEventList.push(m11RPGwj_parseFunction('message("' + m11RPGwj_systemStatus.itemDlg.resultItem.name + 'を捨てた")'));

						m11RPGwj_playerStatus.itemHolder.deleteItem(m11RPGwj_systemStatus.itemDlg.resultItem);
						m11RPGwj_systemStatus.itemDlg.setup(m11RPGwj_playerStatus.itemHolder, m11RPGwj_systemStatus.viewContext);

						winx = (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols - m11RPGwj_systemStatus.commandMessage.getWidth()) / 2;
						winy = (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows - m11RPGwj_systemStatus.commandMessage.getHeight()) / 2;

						m11RPGwj_updateStatus();

						break;

					}

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ENEMYATTACK_IN;

					m11RPGwj_systemStatus.scriptContext = m11RPGwj_ScriptContext.createScriptContext(itemEventList, context);

				}

				break;

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_MAGICMENU:

				// 選択結果に応じた処理へ
				if (m11RPGwj_systemStatus.magicDlg.process(m11RPGwj_systemStatus.controller)) {

					switch (m11RPGwj_systemStatus.magicDlg.getIndex()) {

					// 戻る
					case -1:
					case 0:

						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_COMMAND_IN;

						break;

					// 魔法選択
					default:

						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_MAGICMENU_DONE;

						break;

					}

				}

				break;

			// 魔法処理
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_MAGICMENU_DONE:

				// リターンキー解放を待ってメッセージ表示処理へ
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					item = m11RPGwj_playerStatus.magicList[m11RPGwj_systemStatus.magicDlg.getIndex() - 1];

					if (m11RPGwj_playerStatus.status.mp < item.mp) {

						msg = "MPが足りない！";

						// 戦闘処理画面のメッセージ設定
						m11RPGwj_systemStatus.scriptMeswin.setText(msg, m11RPGwj_systemStatus.viewContext);
						m11RPGwj_systemStatus.scriptMeswin.show();

						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_PLAYERCANSEL_MESSAGE;

					} else {

						m11RPGwj_playerStatus.status.mp -= item.mp;

						if (item.player_effect_type == "heal") {

							m11RPGwj_playerStatus.status.hp += m11RPGwj_getValue(item.player_effect, null);

							if (m11RPGwj_playerStatus.status.hp > m11RPGwj_playerStatus.status.mhp) {
								m11RPGwj_playerStatus.status.hp = m11RPGwj_playerStatus.status.mhp;
							}

							msg = m11RPGwj_playerStatus.status.name + "は" + item.name + "の魔法をかけた";

						}

						if (item.player_effect_type == "damage") {

							dmg = m11RPGwj_getValue(item.player_effect, null);

							m11RPGwj_systemStatus.event_enemy.hp -= dmg;

							msg = m11RPGwj_playerStatus.status.name + "は" + item.name + "の魔法をかけた<:br><:br>" + m11RPGwj_systemStatus.event_enemy.name + "に" + dmg + "のダメージ！";

						}

						// 戦闘処理画面のメッセージ設定
						m11RPGwj_systemStatus.scriptMeswin.setText(msg, m11RPGwj_systemStatus.viewContext);
						m11RPGwj_systemStatus.scriptMeswin.show();

						m11RPGwj_updateStatus();

						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_PLAYERACTION_MESSAGE;

					}

				}

				break;

			// プレイヤー通常攻撃処理開始待機中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_PLAYERATTACK_IN:

				// リターンキー解放を確認したらプレイヤー側通常攻撃処理へ
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					dmg = m11RPGwj_getValue(m11RPGwj_data.scriptFormula.battle_player_attack, null);

					msg = m11RPGwj_playerStatus.status.name + "の攻撃<:br>" + m11RPGwj_systemStatus.event_enemy.name + "に" + dmg + "のダメージ!<:br><:br>";

					m11RPGwj_systemStatus.event_enemy.hp -= dmg;

					// 戦闘処理画面のメッセージ設定
					m11RPGwj_systemStatus.scriptMeswin.setText(msg, m11RPGwj_systemStatus.viewContext);
					m11RPGwj_systemStatus.scriptMeswin.show();

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_PLAYERACTION_MESSAGE;

				}

				break;

			// プレイヤー行動中止メッセージ表示中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_PLAYERCANSEL_MESSAGE:

				// メッセージ表示が終わったらコマンド選択へ戻る
				if (m11RPGwj_systemStatus.scriptMeswin.process(m11RPGwj_systemStatus.controller)) {
					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_COMMAND_IN;
				}

				break;

			// プレイヤー行動メッセージ表示中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_PLAYERACTION_MESSAGE:

				// メッセージ表示が終わったら次へ
				if (m11RPGwj_systemStatus.scriptMeswin.process(m11RPGwj_systemStatus.controller)) {

					// 敵を倒したら勝利
					if (m11RPGwj_systemStatus.event_enemy.hp > 0) {
						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ENEMYATTACK_IN;
					} else {
						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_WIN_IN;
					}

				}

				break;

			// 戦闘処理画面待機中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ENEMYATTACK_IN:

				// リターンキー解放を確認したら戦闘処理画面へ
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					var enemyScriptContext = m11RPGwj_ScriptContext.createScriptContext(m11RPGwj_systemStatus.event_enemy.scriptList, null);

					while (m11RPGwj_script(enemyScriptContext) != m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTEXIT);

					msg = '';
					dmg = 0;

					switch (enemyScriptContext.localVar[0]) {

					case 1:

						for (i = 0;i < m11RPGwj_data.magicList.length;i++) {
							if (m11RPGwj_data.magicList[i].no == enemyScriptContext.localVar[1]) {
								item = m11RPGwj_data.magicList[i];
							}
						}

						m11RPGwj_systemStatus.event_enemy.mp -= item.mp;

						if (item.enemy_effect_type == 'heal') {

							m11RPGwj_systemStatus.event_enemy.hp += m11RPGwj_getValue(item.enemy_effect, null);

							if (m11RPGwj_systemStatus.event_enemy.hp > m11RPGwj_systemStatus.event_enemy.mhp) {
								m11RPGwj_systemStatus.event_enemy.hp = m11RPGwj_systemStatus.event_enemy.mhp;
							}

							msg = m11RPGwj_systemStatus.event_enemy.name + "は" + item.name + "の魔法をかけた！";

						}

						if (item.enemy_effect_type == 'damage') {

							dmg = m11RPGwj_getValue(item.enemy_effect, null);

							msg = m11RPGwj_systemStatus.event_enemy.name + "は" + item.name + "の魔法をかけた！<:br><:br>" + m11RPGwj_playerStatus.status.name + "に" + dmg + "のダメージ！";

						}

						break;

					default:

						dmg = m11RPGwj_getValue(m11RPGwj_data.scriptFormula.battle_enemy_attack, null);

						msg = m11RPGwj_systemStatus.event_enemy.name + "の攻撃<:br>" + m11RPGwj_playerStatus.status.name + "に" + dmg + "のダメージ!";

						break;

					}

					m11RPGwj_playerStatus.status.hp -= dmg;

					if (m11RPGwj_playerStatus.status.hp < 0) {
						m11RPGwj_playerStatus.status.hp = 0;
					}

					// 戦闘処理画面のメッセージ設定
					m11RPGwj_systemStatus.scriptMeswin.setText(msg, m11RPGwj_systemStatus.viewContext);

					// 戦闘処理画面のメッセージ設定
					m11RPGwj_systemStatus.scriptMeswin.setText(msg, m11RPGwj_systemStatus.viewContext);
					m11RPGwj_systemStatus.scriptMeswin.show();

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ENEMYATTACK;

				}

				break;

			// 戦闘処理画面表示中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ENEMYATTACK:

				// ターン終了
				if (m11RPGwj_systemStatus.scriptMeswin.process(m11RPGwj_systemStatus.controller)) {

					// 死亡判定
					if (m11RPGwj_playerStatus.status.hp <= 0) {
						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_LOSE_IN;
					} else {
						context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_COMMAND_IN;
					}

				}

				break;

			// 勝利画面待機中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_WIN_IN:

				// リターンキー解放を確認したら勝利画面へ
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					m11RPGwj_systemStatus.scriptMeswin.setText(m11RPGwj_systemStatus.event_enemy.name + "を倒した!", m11RPGwj_systemStatus.viewContext);

					m11RPGwj_playerStatus.status.exp += m11RPGwj_systemStatus.event_enemy.exp;

					if (m11RPGwj_playerStatus.status.exp > 9999) {
						m11RPGwj_playerStatus.status.exp = 9999;
					}

					m11RPGwj_updateStatus();

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_WIN;

					// 戦闘結果を確認するローカル変数番号を取得
					i = m11RPGwj_getValue(context.list[context.pos].args[1], context);

					// 戦闘結果をローカル変数に格納
					if (i >= 0 && i < context.localVar.length) {
						context.localVar[i] = 1;
					}

				}

				break;

			// 退避成功画面待機中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ESCAPE_IN:

				// リターンキー解放を確認したら退避成功画面へ
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					m11RPGwj_systemStatus.scriptMeswin.setText("退避に成功!", m11RPGwj_systemStatus.viewContext);

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ESCAPE;

					// 戦闘結果を確認するローカル変数番号を取得
					i = m11RPGwj_getValue(context.list[context.pos].args[1], context);

					// 戦闘結果をローカル変数に格納
					if (i >= 0 && i < context.localVar.length) {
						context.localVar[i] = 0;
					}

				}

				break;

			// 敗退画面待機中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_LOSE_IN:

				// リターンキー解放を確認したら敗退画面へ
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					m11RPGwj_systemStatus.scriptMeswin.setText(m11RPGwj_playerStatus.status.name + "は倒れた!", m11RPGwj_systemStatus.viewContext);

					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_LOSE;

					// 戦闘結果を確認するローカル変数番号を取得
					i = m11RPGwj_getValue(context.list[context.pos].args[1], context);

					// 戦闘結果をローカル変数に格納
					if (i >= 0 && i < context.localVar.length) {
						context.localVar[i] = 2;
					}

				}

				break;

			// 勝利／退避成功／敗退画面表示中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_WIN:
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ESCAPE:
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_LOSE:

				if (m11RPGwj_systemStatus.scriptMeswin.process(m11RPGwj_systemStatus.controller)) {
					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_EXIT;
				}

				break;

			// 戦闘処理終了待機中
			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_EXIT:

				// リターンキー解放を確認したら戦闘処理終了
				if (m11RPGwj_systemStatus.controller.getButtons() == m11RPGwj_Controller.KEYFLAG_NONE) {

					m11RPGwj_systemStatus.scriptMeswin.hide();

					m11RPGwj_systemStatus.event_enemy = null;

					context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;

				}

				break;

			}

			break;

		case 'end':

			// 現在の処理状態に応じた処理を実行
			switch (context.stage) {

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_IMAGELOADED:

				m11RPGwj_systemStatus.loaded_image = m11RPGwj_systemStatus.loading_image;

				m11RPGwj_systemStatus.loading_image = null;

				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_MUSICLOADING;

				break;

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_MUSICLOADING:

				m11RPGwj_soundMenuSync();

				m11RPGwj_playMusic(m11RPGwj_systemStatus.loading_audio);

				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_END;

				break;

			case m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_END:

				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;

				m11RPGwj_systemStatus.app_status = m11RPGwj_SystemStatus.APPSTATE_END;

				break;

			}


			break;

		}

		// スクリプト処理を一時中断してメイン処理を実行
		return m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTBREAK;

	// コード実行終了
	case m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT:

		// スクリプト処理完了検査
		if (++context.pos < context.list.length) {

			// まだ実行すべきスクリプト関数があれば次のスクリプト関数へ
			context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODELOAD;

			// m11RPGwj_script()呼び出し継続
			return m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTEXEC;

		} else {

			// m11RPGwj_script()呼び出し終了
			return m11RPGwj_ScriptContext.SCRIPTRSULT_SCRIPTEXIT;

		}

		break;

	}

}

// 指定文字列の先頭と末尾にある空白文字を削除した文字列を返す
function trim(str) {

	if (str == null || str.length < 1) {
		return null;
	}

	var result;

	var start_index = 0;
	var last_index = str.length - 1;

	// 行頭から空白文字でない文字が出てくる位置を検索
	while (start_index < str.length && (str.charAt(start_index) == ' ' || str.charAt(start_index) == "\t" || str.charAt(start_index) == "\r"  || str.charAt(start_index) == "\n")) {
		start_index++;
	}

	// 空白文字のみの文字列ならnullを返す
	if (start_index == str.length) {
		return null;
	}

	// 行末から空白文字でない文字が出てくる位置を検索
	while (last_index >= 0 && (str.charAt(last_index) == ' ' || str.charAt(last_index) == "\t" || str.charAt(last_index) == "\r"  || str.charAt(last_index) == "\n")) {
		last_index--;
	}

	return str.substring(start_index, last_index + 1);

}

function m11RPGwj_isString(arg) {

	var i;

	// 空文字列なら偽
	if (arg == null || arg.length < 1) {
		return false;
	}

	// 最初と最後が"でなければ偽
	if (arg.charAt(0) != '"' || arg.charAt(arg.length - 1) != '"') {
		return false;
	}

	// 途中に"が出てきたら偽
	for (i = 1;i < arg.length - 1;i++) {
		if (arg.charAt(i) == '"') {
			return false;
		}
	}

	// 最後まで条件違反がなければ真
	return true;

}

// 文字列が数字か検査
function m11RPGwj_isNum(arg) {

	var i;

	// 空文字列なら偽
	if (arg == null || arg.length < 1) {
		return false;
	}

	str = new String(arg);

	if (arg == null || arg.length < 1) {
		return false;
	}

	// 0-9以外の文字が出てきたら偽
	for (i = 0;i < str.length;i++) {
		if (str.charAt(i) < '0' || str.charAt(i) > '9') {
			return false;
		}
	}

	// 最後まで条件違反がなければ真
	return true;

}

// 渡された文字列をスクリプトとして実行・評価し数値を返す
function m11RPGwj_getValue(str, context) {

	// 数字からなる文字列なら数値化して返す
	if (m11RPGwj_isNum(str)) {
		return parseInt(str);
	}

	// スクリプト関数として実行（計算）しその値を返す
	return m11RPGwj_getFunctionValue(m11RPGwj_parseFunction(str), context);

}

// 渡された文字列をスクリプトとして実行・評価し論理値を返す
function m11RPGwj_getBoolValue(str, context) {

	return m11RPGwj_getFunctionBoolValue(m11RPGwj_parseFunction(str), context);

}

// 文字列をスクリプト関数として解析し、スクリプトオブジェクトを返す
function m11RPGwj_parseFunction(arg) {

	if (arg == null) {
		return null;
	}

	var str = trim(arg);

	if (str == null || str.length < 3) {
		return null;
	}

	// 文字列内で(の次（引数の最初）の位置を取得
	var arg_start_index = str.indexOf("(") + 1;

	var result = new m11RPGwj_ScriptCode();

	// 関数名を設定
	result.name = str.substring(0, arg_start_index - 1);

	// 引数の文字列を取得
	var func_arg = str.substring(arg_start_index, str.length - 1);

	// 引数を切り分け引数配列を作成
	result.args = m11RPGwj_getArgList(func_arg);

	// 文字列を保存
	result.script = str;

	return result;

}

// スクリプト関数を実行・評価し数値を返す
function m11RPGwj_getFunctionValue(func, context) {

	var val;
	var arg, arg1, arg2;

	var i;

	// sum()関数
	if (func.name == 'sum') {

		val = 0;

		// 引数を数値として加算していく
		for (i = 0;i < func.args.length;i++) {
			val += m11RPGwj_getValue(func.args[i], context);
		}

		// 加算結果を返す
		return val;

	}

	// add()関数
	if (func.name == 'add') {

		if (func.args.length == 2) {

			arg1 = m11RPGwj_getValue(func.args[0], context);
			arg2 = m11RPGwj_getValue(func.args[1], context);

			// 演算結果を返す
			return arg1 + arg2;

		}

	}

	// sub()関数
	if (func.name == 'sub') {

		if (func.args.length == 2) {

			arg1 = m11RPGwj_getValue(func.args[0], context);
			arg2 = m11RPGwj_getValue(func.args[1], context);

			// 演算結果を返す
			return arg1 - arg2;

		}

	}

	// mul()関数
	if (func.name == 'mul') {

		if (func.args.length == 2) {

			arg1 = m11RPGwj_getValue(func.args[0], context);
			arg2 = m11RPGwj_getValue(func.args[1], context);

			// 演算結果を返す
			return arg1 * arg2;

		}

	}

	// div()関数
	if (func.name == 'div') {

		if (func.args.length == 2) {

			arg1 = m11RPGwj_getValue(func.args[0], context);
			arg2 = m11RPGwj_getValue(func.args[1], context);

			// 演算結果を返す
			return parseInt(arg1 / arg2);

		}

	}

	// sqrt()関数
	if (func.name == 'sqrt') {

		if (func.args.length == 1) {

			arg = m11RPGwj_getValue(func.args[0], context);

			// 演算結果を返す
			return parseInt(Math.sqrt(arg));

		}

	}

	// rand()関数
	if (func.name == 'rand') {

		if (func.args.length == 1) {

			// 引数値を取得
			arg = m11RPGwj_getValue(func.args[0], context);

			// 乱数値を返す
			return parseInt(Math.random() * arg);

		}

	}

	// getVar()関数
	if (func.name == 'getVar') {

		if (func.args.length == 1) {

			// 変数番号を取得
			arg = m11RPGwj_getValue(func.args[0], context);

			// 変数番号が有効なら対応する変数の値を返す
			if (arg >= 0 && arg <= 99) {
				return m11RPGwj_playerStatus.varList[arg];
			}

		}

	}

	if (func.name == 'getLocalVar') {

		if (func.args.length == 1 && context != null) {

			// 変数番号を取得
			arg = m11RPGwj_getValue(func.args[0], context);

			// 変数番号が有効なら対応する変数の値を返す
			if (arg >= 0 && arg <= 16) {
				return context.localVar[arg];
			}

		}

	}

	// getItemNum()関数
	if (func.name == 'getItemNum') {

		if (func.args.length == 1) {

			// 引数を数値評価
			arg = m11RPGwj_getValue(func.args[0], context);

			return m11RPGwj_playerStatus.itemHolder.getNumOfItem(arg);

		}

	}

	// getItemSpace()関数
	if (func.name == 'getItemSpace') {
		return m11RPGwj_playerStatus.itemHolder.getItemSpace();
	}

	// getPlayerStatus()関数
	if (func.name == 'getPlayerStatus') {

		if (func.args.length == 1) {
			return m11RPGwj_playerStatus.status.getStatus(func.args[0].substring(1, func.args[0].length - 1));
		}

	}

	// getEnemyStatus()関数
	if (func.name == 'getEnemyStatus') {

		if (func.args.length == 1 && m11RPGwj_systemStatus.event_enemy != null) {
			return m11RPGwj_systemStatus.event_enemy.getStatus(func.args[0].substring(1, func.args[0].length - 1));
		}

	}

	return Number.NaN;

}

// スクリプト関数を実行・評価し論理値を返す
function m11RPGwj_getFunctionBoolValue(func, context) {

	var i;
	var val1, val2;

	// eq()関数
	if (func.name == 'eq') {

		if (func.args.length == 2) {

			// 引数を値として評価
			val1 = m11RPGwj_getValue(func.args[0], context);
			val2 = m11RPGwj_getValue(func.args[1], context);

			// 等しければtrue、等しくなければfalseを返す
			return (val1 == val2);

		}

	}

	// ne()関数
	if (func.name == 'ne') {

		if (func.args.length == 2) {

			// 引数を値として評価
			val1 = m11RPGwj_getValue(func.args[0], context);
			val2 = m11RPGwj_getValue(func.args[1], context);

			// 等しくなればtrue、等しければfalseを返す
			return (val1 != val2);

		}

	}

	// lt()関数
	if (func.name == 'lt') {

		if (func.args.length == 2) {

			// 引数を値として評価
			val1 = m11RPGwj_getValue(func.args[0], context);
			val2 = m11RPGwj_getValue(func.args[1], context);

			// <演算子の結果を返す
			return (val1 < val2);

		}

	}

	// gt()関数
	if (func.name == 'gt') {

		if (func.args.length == 2) {

			// 引数を値として評価
			val1 = m11RPGwj_getValue(func.args[0], context);
			val2 = m11RPGwj_getValue(func.args[1], context);

			// >演算子の結果を返す
			return (val1 > val2);

		}

	}

	// le()関数
	if (func.name == 'le') {

		if (func.args.length == 2) {

			// 引数を値として評価
			val1 = m11RPGwj_getValue(func.args[0], context);
			val2 = m11RPGwj_getValue(func.args[1], context);

			// <演算子の結果を返す
			return (val1 <= val2);

		}

	}

	// ge()関数
	if (func.name == 'ge') {

		if (func.args.length == 2) {

			// 引数を値として評価
			val1 = m11RPGwj_getValue(func.args[0], context);
			val2 = m11RPGwj_getValue(func.args[1], context);

			// >演算子の結果を返す
			return (val1 >= val2);

		}

	}

	// and関数
	if (func.name == 'and') {

		if (func.args.length > 0) {

			// 引数の論理値を順次取得しfalseがあればfalse
			for (i = 0;i < func.args.length;i++) {
				if (!m11RPGwj_getBoolValue(func.args[i], context)) {
					return false;
				}
			}

			// 引数がすべて真ならtrue
			return true;

		}

	}

	// or関数
	if (func.name == 'or') {

		if (func.args.length > 0) {

			// 引数の論理値を順次取得しtrueがあればtrue
			for (i = 0;i < func.args.length;i++) {
				if (m11RPGwj_getBoolValue(func.args[i], context)) {
					return true;
				}
			}

			// 引数がすべて偽ならfalse
			return false;

		}

	}

}

// スクリプトオブジェクトを実行・評価し、その値を返す
function m11RPGwj_execFunction(func, context) {

	var i;
	var sum = 0;
	var str = '';
	var val;
	var arg, arg1, arg2, arg3;
	var val1, val2, val3;
	var list;
	var winx, winy;
	var file_name = '';

	// 数値型計算関数
	switch (func.name) {

	case 'sum':
	case 'add':
	case 'sub':
	case 'mul':
	case 'div':
	case 'sqrt':
	case 'rand':
	case 'getVar':
	case 'getItemNum':
	case 'getItemSpace':
	case 'getPlayerStatus':
	case 'getEnemyStatus':
	case 'getLocalVar':

		if (context != null) {
			context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
		}

		return m11RPGwj_getFunctionValue(func, context);

	case 'eq':
	case 'ne':
	case 'lt':
	case 'gt':
	case 'le':
	case 'ge':
	case 'and':
	case 'or':

		if (context != null) {
			context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
		}

		return m11RPGwj_getFunctionBoolValue(func, context);

	}

	// setPlayerStatus()関数
	if (func.name == 'setPlayerStatus') {

		if (func.args.length == 2) {

			// ""を削除し中身の文字列を取得
			str = func.args[0].substring(1, func.args[0].length - 1);

			// 代入値を取得
			val = m11RPGwj_getValue(func.args[1], context);

			m11RPGwj_playerStatus.status.setStatus(str, val);

			if (context != null) {
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
			}

			return val;

		}

	}

	// setLocalVar()関数
	if (func.name == 'setLocalVar') {

		if (func.args.length == 2 && context != null) {

			context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;

			// 変数番号を取得
			i = m11RPGwj_getValue(func.args[0], context);

			// 代入値を取得
			val = m11RPGwj_getValue(func.args[1], context);

			// 変数番号が有効なら代入を実行し、その値を返す
			if (i >= 0 && i <= 16) {

				context.localVar[i] = val;

				return val;

			}

		}

	}

	// setVar()関数
	if (func.name == 'setVar') {

		if (func.args.length == 2) {

			// 変数番号を取得
			i = m11RPGwj_getValue(func.args[0], context);

			// 代入値を取得
			val = m11RPGwj_getValue(func.args[1], context);

			if (context != null) {
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
			}

			// 変数番号が有効なら代入を実行し、その値を返す
			if (i >= 0 && i <= 99) {

				m11RPGwj_playerStatus.varList[i] = val;

				return val;

			}

		}

	}

	// setChar()関数
	if (func.name == 'setChar') {

		if (func.args.length == 1) {

			// キャラクタ番号を設定
			m11RPGwj_playerStatus.char_no = m11RPGwj_getValue(func.args[0], context);

			if (context != null) {
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
			}

			return m11RPGwj_playerStatus.char_no;

		}

	}


	// move()関数
	if (func.name == 'move') {

		if (func.args.length == 3 || func.args.length == 4) {

			// 引数を値として評価
			val1 = m11RPGwj_getValue(func.args[0], context);
			val2 = m11RPGwj_getValue(func.args[1], context);
			val3 = m11RPGwj_getValue(func.args[2], context);

			// 移動を反映（描画）させるためスクリプト実行中状態へ
			if (context != null) {

				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXEC;
				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MOVE_BLACKOUT_IN;

			}

			m11RPGwj_systemStatus.move_count = 1;

			m11RPGwj_systemStatus.move_pos.map = m11RPGwj_data.getMapIndex(val1);
			m11RPGwj_systemStatus.move_pos.x = val2;
			m11RPGwj_systemStatus.move_pos.y = val3;

			// canvasの背景色を設定
			m11RPGwj_systemStatus.viewCanvas.style.background = '#000000';

			m11RPGwj_systemStatus.loading_audio = null;

			// BGM設定
			if (func.args.length == 4) {

				m11RPGwj_playerStatus.bgm = null;

				// 既存のAudioオブジェクトがあれば破棄
				if (m11RPGwj_systemStatus.bgmPlayer != null) {

					m11RPGwj_systemStatus.bgmPlayer.pause();

					delete m11RPGwj_systemStatus.bgmPlayer;

					m11RPGwj_systemStatus.bgmPlayer = null;

				}

				// BGMの曲名を取得
				str = trim(func.args[3]);

				if (str.length > 2) {

					str = str.substring(1, str.length - 1);

					m11RPGwj_systemStatus.loading_audio = str;

				} else {
					m11RPGwj_systemStatus.loading_audio = null;
				}

			}

			return m11RPGwj_playerStatus.x;

		}

	}

	// addItem()関数
	if (func.name == 'addItem') {

		if (func.args.length == 1) {

			// 引数を数値評価
			val = m11RPGwj_getValue(func.args[0], context);

			// 指定番号の道具を追加
			m11RPGwj_playerStatus.itemHolder.addItem(new m11RPGwj_PlayerItem(m11RPGwj_data.playerItemList[val]));

			if (context != null) {
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
			}

			return true;

		}

	}

	// decItem()関数
	if (func.name == 'decItem') {

		if (func.args.length == 1) {

			// 引数を数値評価
			val = m11RPGwj_getValue(func.args[0], context);

			// 指定番号の道具を削除
			m11RPGwj_playerStatus.itemHolder.decItem(val);

			m11RPGwj_updateStatus();

			if (context != null) {
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
			}

			return true;

		}

	}

	// message()関数
	if (func.name == 'message') {

		// 引数は単一の文字列のみ有効
		if (func.args.length == 1 && m11RPGwj_isString(func.args[0])) {

			// ""を削除し中身の文字列を取得
			str = func.args[0].substring(1, func.args[0].length - 1);

			// スクリプト用メッセージ表示ウインドウに表示文字列を設定
			m11RPGwj_systemStatus.scriptMeswin.setText(str, m11RPGwj_systemStatus.viewContext);

			winx = ((m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) - m11RPGwj_systemStatus.scriptMeswin.getWidth()) / 2;
			winy = (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) - m11RPGwj_systemStatus.scriptMeswin.getHeight() - m11RPGwj_config.chip_height;

			m11RPGwj_systemStatus.scriptMeswin.setPos(winx, winy);

			// スクリプト用メッセージ表示ウインドウを表示状態に
			m11RPGwj_systemStatus.scriptMeswin.show();

			// スクリプト実行中状態へ
			if (context != null) {

				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXEC;
				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_MESSAGE_VIEW;

			}

			// メッセージ文字列を値とする
			return str;

		}

	}

	// select()関数
	if (func.name == 'select') {

		if (func.args.length > 2) {

			list = new Array();

			for (i = 1;i < func.args.length;i++) {

				// ""を削除し中身の文字列を取得
				str = trim(func.args[i]);
				str = str.substring(1, str.length - 1);

				list.push(str);

			}

			// スクリプト用選択ダイアログに選択肢を設定
			m11RPGwj_systemStatus.scriptSelectDlg.setItems(list, m11RPGwj_systemStatus.viewContext);

			winx = ((m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) - m11RPGwj_systemStatus.scriptSelectDlg.getWidth()) / 2;
			winy = ((m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) - m11RPGwj_systemStatus.scriptSelectDlg.getHeight()) / 2;

			m11RPGwj_systemStatus.scriptSelectDlg.setPos(winx, winy);

			// スクリプト用選択ダイアログを表示状態に
			m11RPGwj_systemStatus.scriptSelectDlg.show();

			// スクリプト実行中状態へ
			if (context != null) {
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXEC;
			}

			// ダイアログを値とする
			return m11RPGwj_systemStatus.scriptSelectDlg;

		}

	}

	// image()関数
	if (func.name == 'image') {

		if (func.args.length == 1) {

			if (context != null) {

				// スクリプト実行中状態へ
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXEC;

				// 画像読み込み中状態へ
				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_LOADING;

			}


			// スクリプト画像オブジェクト作成
			m11RPGwj_systemStatus.loading_image = new Image();

			// 読み込みが終わったら読み込み完了状態へ
			m11RPGwj_systemStatus.loading_image.onload = function() {
				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_LOADED;
			}

			str = trim(func.args[0]);
			str = str.substring(1, str.length - 1);

			// 読み込む画像を設定
			m11RPGwj_systemStatus.loading_image.src = str;

			return m11RPGwj_systemStatus.loading_image;

		}

	}

	// 動画再生
	if (func.name == 'playVideo') {

		if (func.args.length == 1) {

			// 再生する動画名を取得
			str = trim(func.args[0]);
			str = str.substring(1, str.length - 1);

			file_name = str;

			// 動画の拡張子（形式）を決定
			if (m11RPGwj_systemStatus.videoPlayer.canPlayType("video/ogg") == "maybe" || m11RPGwj_systemStatus.videoPlayer.canPlayType("video/ogg") == "probably") {
				file_name = file_name + '.ogv';
			} else {
				file_name = file_name + '.mp4';
			}

			if (context != null) {

				// スクリプト実行中状態へ
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXEC;

				// 動画読み込み中状態へ
				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_LOADING;

			}

			// 読み込みイベントで読み込み完了状態へ
			m11RPGwj_systemStatus.videoPlayer.addEventListener("loadeddata", function() {
				if (context.stage == m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_LOADING) {
					context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_VIDEO_LOADED;
				}
			}, false);

			// video要素に再生する動画を設定
			m11RPGwj_systemStatus.videoPlayer.src = file_name;
			m11RPGwj_systemStatus.videoPlayer.load();

			return true;

		}

	}

	// BGM停止
	if (func.name == 'stopBGM') {

		// 既存のAudioオブジェクトがあれば破棄
		if (m11RPGwj_systemStatus.bgmPlayer != null) {

			m11RPGwj_systemStatus.bgmPlayer.pause();

			delete m11RPGwj_systemStatus.bgmPlayer;

			m11RPGwj_systemStatus.bgmPlayer = null;

		}

		if (context != null) {
			context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
		}

		return true;

	}

	// BGM設定
	if (func.name == 'setBGM') {

		if (func.args.length == 1) {

			// BGMの曲名を取得
			str = trim(func.args[0]);
			str = str.substring(1, str.length - 1);

			m11RPGwj_setBGM(str);

			if (context != null) {
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
			}

			return true;

		}

	}

	// 画面フラッシュ
	if (func.name == 'flash') {

		if (func.args.length == 1) {

			str = trim(func.args[0]);
			m11RPGwj_systemStatus.bg_color = str.substring(1, str.length - 1);

			// canvasの背景色を設定
			m11RPGwj_systemStatus.viewCanvas.style.background = m11RPGwj_systemStatus.bg_color;

			if (context != null) {

				// スクリプト実行中状態へ
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXEC;

				// フラッシュ開始状態に
				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_FLASH_IN;

			}

			m11RPGwj_systemStatus.flash_count = 0;

			return true;

		}

	}

	// battle()関数
	if (func.name == 'battle') {

		if (func.args.length == 2) {

			// 引数の敵番号取得
			i = m11RPGwj_getValue(func.args[0], context);

			// 敵オブジェクト作成
			m11RPGwj_systemStatus.event_enemy = new m11RPGwj_Enemy(m11RPGwj_data.enemyList[i]);

			// スクリプト用メッセージ表示ウインドウに表示文字列を設定
			m11RPGwj_systemStatus.scriptMeswin.setText(m11RPGwj_systemStatus.event_enemy.name + "と遭遇!", m11RPGwj_systemStatus.viewContext);

			winx = ((m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) - m11RPGwj_systemStatus.scriptMeswin.getWidth()) / 2;
			winy = (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) - m11RPGwj_systemStatus.scriptMeswin.getHeight() - m11RPGwj_config.chip_height;

			m11RPGwj_systemStatus.scriptMeswin.setPos(winx, winy);

			// スクリプト用メッセージ表示ウインドウを表示状態に
			m11RPGwj_systemStatus.scriptMeswin.show();

			list = new Array();

			list.push("戦う");
			list.push("道具");
			list.push("魔法");
			list.push("逃げる");

			// スクリプト用選択ダイアログに選択肢を設定
			m11RPGwj_systemStatus.scriptSelectDlg.setItems(list, m11RPGwj_systemStatus.viewContext);

			winx = ((m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) - m11RPGwj_systemStatus.scriptSelectDlg.getWidth()) / 2;
			winy = ((m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) - m11RPGwj_systemStatus.scriptSelectDlg.getHeight()) / 2;

			m11RPGwj_systemStatus.scriptSelectDlg.setPos(winx, winy);

			// 引数の敵番号取得
			i = m11RPGwj_getValue(func.args[1], context);

			// 指定変数を0に設定
			m11RPGwj_playerStatus.varList[i] = 0;

			if (context != null) {

				// スクリプト実行中状態へ
				context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXEC;

				// 戦闘開始状態に
				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_START;

			}

			return m11RPGwj_systemStatus.event_enemy;

		}

	}

	// end()関数
	if (func.name == 'end') {

		if (func.args.length == 2) {

			m11RPGwj_setBGM(null);

			m11RPGwj_systemStatus.loading_image = null;
			m11RPGwj_systemStatus.loaded_image = null;
			m11RPGwj_systemStatus.loading_audio = null;
			m11RPGwj_systemStatus.loaded_audio = null;

			var img = trim(func.args[0]);
			img = img.substring(1, img.length - 1);

			if (img.length < 1) {
				img = null;
			}

			var music = trim(func.args[1]);
			music = music.substring(1, music.length - 1);

			if (music.length < 1) {
				music = null;
			}

			if (img == null) {
				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_END;
			} else {

				m11RPGwj_systemStatus.loading_image = new Image();

				m11RPGwj_systemStatus.loading_image.onload = function() { context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_IMAGELOADED; };

				m11RPGwj_systemStatus.loading_image.src = img;

				context.stage = m11RPGwj_ScriptContext.SCRIPTCODESTAGE_END_IMAGELOADING;

				m11RPGwj_systemStatus.loading_audio = music;

			}

			// スクリプト実行中状態へ
			context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXEC;

			return 0;

		}

	}

	if (context != null) {
		context.status = m11RPGwj_ScriptContext.SCRIPTSTATE_CODEEXIT;
	}

	return undefined;

}

// 引数分離処理
function m11RPGwj_getArgList(text) {

	var arg_level = 0;
	var quote_flag = false;

	var arg_item = '';

	var c;
	var i;

	var result = new Array();

	// 引数文字列から個々の引数を切り出す
	for (i = 0;i < text.length;i++) {

		// 現在位置の文字を取得
		c = text.charAt(i);

		// 引用符の中ならそのまま追記
		if (quote_flag) {

			// "が出てきたら引用文字列終了
			if (c == '"') {
				quote_flag = false;
			}

			// 引数候補文字列に現在位置の文字を追加
			arg_item += c;

		} else {

			// (が出てきたら引数レベル加算
			if (c == '(') {
				arg_level++;
			}

			// ()内ならそのまま追記
			if (arg_level > 0) {

				// )が出てきたら引数レベル減算
				if (c == ')') {
					arg_level--;
				}

				// 引数候補文字列に現在位置の文字を追加
				arg_item += c;

			} else {

				// ,が出てきたら、現在の文字列を引数として確定
				if (c == ',') {

					// 現在の引数候補文字列を引数として追加
					result.push(trim(arg_item));

					// 引数候補文字列を初期化
					arg_item = '';

				} else {

					// 引数候補文字列に現在位置の文字を追加
					arg_item += c;

					// "が出てきたら引用符フラグ設定
					if (c == '"') {
						quote_flag = true;
					}

				}

			}

		}

		// 引数文字列の最後まで処理したら、最後の引数を追加
		if (i == text.length - 1) {
			result.push(trim(arg_item));
		}

	}

	return result;

}

function m11RPGwj_hasItem(list, item) {

	if (!list || list.length < 1) {
		return false;
	}

	var i;

	for (i = 0;i < list.length;i++) {
		if (list[i] == item) {
			return true;
		}
	}

	return false;

}

// 成長やアイテム効果などステータス再計算
function m11RPGwj_updateStatus() {

	var i;
	var item;

	if (m11RPGwj_data.scriptFormula.player_mhp_base != null) {
		m11RPGwj_playerStatus.status.mhp_base = m11RPGwj_getValue(m11RPGwj_data.scriptFormula.player_mhp_base, null);
	}

	if (m11RPGwj_data.scriptFormula.player_mmp_base != null) {
		m11RPGwj_playerStatus.status.mmp_base = m11RPGwj_getValue(m11RPGwj_data.scriptFormula.player_mmp_base, null);
	}

	if (m11RPGwj_data.scriptFormula.player_at_base != null) {
		m11RPGwj_playerStatus.status.at_base = m11RPGwj_getValue(m11RPGwj_data.scriptFormula.player_at_base, null);
	}

	if (m11RPGwj_data.scriptFormula.player_def_base != null) {
		m11RPGwj_playerStatus.status.def_base = m11RPGwj_getValue(m11RPGwj_data.scriptFormula.player_def_base, null);
	}

	if (m11RPGwj_data.scriptFormula.player_mf_base != null) {
		m11RPGwj_playerStatus.status.mf_base = m11RPGwj_getValue(m11RPGwj_data.scriptFormula.player_mf_base, null);
	}

	m11RPGwj_playerStatus.status.at_e = 0;
	m11RPGwj_playerStatus.status.def_e = 0;
	m11RPGwj_playerStatus.status.mf_e = 0;

	// 装備アイテムの装備効果を積算
	for (i = 0;i < m11RPGwj_playerStatus.itemHolder.getItemNum();i++) {

		var item = m11RPGwj_playerStatus.itemHolder.getItem(i);

		if (item.equip && item.equip_effect != null) {

			effect = item.equip_effect.split(":");

			switch (effect[0]) {

			case 'at':

				m11RPGwj_playerStatus.status.at_e += parseInt(effect[1]);

				break;

			case 'def':

				m11RPGwj_playerStatus.status.def_e += parseInt(effect[1]);

				break;

			}

		}

	}

	// 基本値に装備効果を加えて実質ステータス算出
	m11RPGwj_playerStatus.status.mhp = m11RPGwj_playerStatus.status.mhp_base + m11RPGwj_playerStatus.status.mhp_e;
	m11RPGwj_playerStatus.status.mmp = m11RPGwj_playerStatus.status.mmp_base + m11RPGwj_playerStatus.status.mmp_e;
	m11RPGwj_playerStatus.status.at = m11RPGwj_playerStatus.status.at_base + m11RPGwj_playerStatus.status.at_e;
	m11RPGwj_playerStatus.status.def = m11RPGwj_playerStatus.status.def_base + m11RPGwj_playerStatus.status.def_e;
	m11RPGwj_playerStatus.status.mf = m11RPGwj_playerStatus.status.mf_base + m11RPGwj_playerStatus.status.mf_e;

}

// コマンドモード時
function m11RPGwj_command() {

	var list;
	var winx, winy;
	var item;
	var itemEventList;

	switch (m11RPGwj_systemStatus.command_status) {

	// コマンドダイアログ初期化
	case m11RPGwj_SystemStatus.COMMANDSTATE_INIT:

		list = new Array();

		list.push("戻る");
		list.push("道具");
		list.push("魔法");
		list.push("状態");
		list.push("保存");

		m11RPGwj_systemStatus.commandDlg.reset();

		m11RPGwj_systemStatus.commandDlg.setItems(list, m11RPGwj_systemStatus.viewContext);
		m11RPGwj_systemStatus.commandDlg.setCancelable(true);

		m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_COMMANDMENU_IN;

		winx = ((m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) - m11RPGwj_systemStatus.commandDlg.getWidth()) / 2;
		winy = ((m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) - m11RPGwj_systemStatus.commandDlg.getHeight()) / 2;

		m11RPGwj_systemStatus.commandDlg.setPos(winx, winy);

		m11RPGwj_systemStatus.commandDlg.show();

		break;

	// コマンドダイアログ表示待機
	case m11RPGwj_SystemStatus.COMMANDSTATE_COMMANDMENU_IN:

		// リターンキー解放を待ってダイアログ表示へ
		if (m11RPGwj_systemStatus.controller.getButtons() == 0) {
			m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_COMMANDMENU;
		}

		break;

	// コマンドダイアログ表示
	case m11RPGwj_SystemStatus.COMMANDSTATE_COMMANDMENU:

		// ダイアログ選択結果に応じた処理へ
		if (m11RPGwj_systemStatus.commandDlg.process(m11RPGwj_systemStatus.controller)) {

			switch (m11RPGwj_systemStatus.commandDlg.getIndex()) {

			// 戻る／キャンセル
			case -1:
			case 0:

				return true;

			// 道具
			case 1:

				m11RPGwj_systemStatus.itemDlg.setup(m11RPGwj_playerStatus.itemHolder, m11RPGwj_systemStatus.viewContext);

				winx = (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) / 2;
				winy = (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) / 2;

				m11RPGwj_systemStatus.itemDlg.setPos(winx, winy);

				m11RPGwj_systemStatus.itemDlg.reset();
				m11RPGwj_systemStatus.itemDlg.show();

				m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_ITEMMENU;

				break;

			// 魔法
			case 2:

				m11RPGwj_playerStatus.magicList = new Array();

				list = new Array();
				list.push("戻る");

				// 使用可能な魔法を列挙
				for (i = 0;i < m11RPGwj_data.magicList.length;i++) {
					if (m11RPGwj_data.magicList[i].player_effect_type == 'heal' && m11RPGwj_getBoolValue(m11RPGwj_data.magicList[i].cond, null)) {

						m11RPGwj_playerStatus.magicList.push(m11RPGwj_data.magicList[i]);
						list.push(m11RPGwj_data.magicList[i].name);

					}
				}

				m11RPGwj_systemStatus.magicDlg.reset();

				m11RPGwj_systemStatus.magicDlg.setItems(list, m11RPGwj_systemStatus.viewContext);
				m11RPGwj_systemStatus.magicDlg.setCancelable(true);

				winx = ((m11RPGwj_config.chip_width * m11RPGwj_config.view_cols) / 2) - m11RPGwj_systemStatus.magicDlg.getWidth();
				winy = ((m11RPGwj_config.chip_height * m11RPGwj_config.view_rows) - m11RPGwj_systemStatus.magicDlg.getHeight()) / 2;

				m11RPGwj_systemStatus.magicDlg.setPos(winx, winy);

				m11RPGwj_systemStatus.magicDlg.show();

				m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_MAGICMENU;

				break;

			// 状態
			case 3:

				m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_STATUS_INIT;

				break;

			// 保存
			case 4:

				m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_SAVE_EXEC;

				break;

			}

		}

		break;

	// 道具ダイアログ表示中
	case m11RPGwj_SystemStatus.COMMANDSTATE_ITEMMENU:

		// 選択結果に応じた処理へ
		if (m11RPGwj_systemStatus.itemDlg.process(m11RPGwj_systemStatus.controller)) {

			if (m11RPGwj_systemStatus.itemDlg.resultItem == null) {
				m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_INIT;
			} else {
				m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_ITEM_DONE_IN;
			}

		}

		break;

	// 道具メニュー終了時の処理
	case m11RPGwj_SystemStatus.COMMANDSTATE_ITEM_DONE_IN:

		// リターンキー解放を待って終了処理
		if (m11RPGwj_systemStatus.controller.getButtons() == 0) {

			switch (m11RPGwj_systemStatus.itemDlg.result) {

			// 道具使用
			case m11RPGwj_ItemDialog.RESULT_USE:

				itemEventList = new Array();

				if (m11RPGwj_systemStatus.itemDlg.resultItem.field_message != null) {
					itemEventList.push(m11RPGwj_parseFunction('message("' + m11RPGwj_systemStatus.itemDlg.resultItem.field_message + '")'));
				}

				if (m11RPGwj_systemStatus.itemDlg.resultItem.field_effect != null && m11RPGwj_systemStatus.itemDlg.resultItem.field_effect.length > 0) {
					itemEventList.push(m11RPGwj_parseFunction(m11RPGwj_systemStatus.itemDlg.resultItem.field_effect));
				}

				// 使用回数制限があれば使用可能回数を減らす
				if (m11RPGwj_systemStatus.itemDlg.resultItem.useNum > 0) {

					// 使用可能回数を1減らす
					m11RPGwj_systemStatus.itemDlg.resultItem.useNum--;

					// 使用可能回数が0になったらアイテム削除
					if (m11RPGwj_systemStatus.itemDlg.resultItem.useNum == 0) {
						m11RPGwj_playerStatus.itemHolder.deleteItem(m11RPGwj_systemStatus.itemDlg.resultItem);
					}

				}

				if (itemEventList.length > 0) {

					m11RPGwj_systemStatus.scriptContext = m11RPGwj_ScriptContext.createScriptContext(itemEventList, null);

					// スクリプト処理中状態へ移行
					m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.GMAESTATE_SCRIPT;

				} else {
					m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_ITEM_DONE;
				}

				break;

			// 道具装備
			case m11RPGwj_ItemDialog.RESULT_EQUIP:

				itemEventList = new Array();

				if (m11RPGwj_systemStatus.itemDlg.resultItem.equip) {
					itemEventList.push(m11RPGwj_parseFunction('message("' + m11RPGwj_systemStatus.itemDlg.resultItem.name + 'を外した")'));
				} else {
					itemEventList.push(m11RPGwj_parseFunction('message("' + m11RPGwj_systemStatus.itemDlg.resultItem.name + 'を装備した")'));
				}

				// 装備状態設定
				m11RPGwj_playerStatus.itemHolder.setEquip(m11RPGwj_systemStatus.itemDlg.resultItem, !m11RPGwj_systemStatus.itemDlg.resultItem.equip);

				m11RPGwj_updateStatus();

				m11RPGwj_systemStatus.scriptContext = m11RPGwj_ScriptContext.createScriptContext(itemEventList, null);

				// スクリプト処理中状態へ移行
				m11RPGwj_systemStatus.game_status = m11RPGwj_SystemStatus.GMAESTATE_SCRIPT;

				break;

			// 道具捨てる
			case m11RPGwj_ItemDialog.RESULT_DISPOSE:

				m11RPGwj_systemStatus.commandMessage.setText(m11RPGwj_systemStatus.itemDlg.resultItem.name + "を捨てた", m11RPGwj_systemStatus.viewContext);

				m11RPGwj_playerStatus.itemHolder.deleteItem(m11RPGwj_systemStatus.itemDlg.resultItem);
				m11RPGwj_systemStatus.itemDlg.setup(m11RPGwj_playerStatus.itemHolder, m11RPGwj_systemStatus.viewContext);

				winx = (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols - m11RPGwj_systemStatus.commandMessage.getWidth()) / 2;
				winy = (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows - m11RPGwj_systemStatus.commandMessage.getHeight()) / 2;

				m11RPGwj_systemStatus.commandMessage.setPos(winx, winy);

				m11RPGwj_systemStatus.commandMessage.show();

				m11RPGwj_updateStatus();

				m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_ITEM_DONE;

				break;

			}

		}

		break;

	case m11RPGwj_SystemStatus.COMMANDSTATE_ITEM_DONE:

		if (m11RPGwj_systemStatus.commandMessage.process(m11RPGwj_systemStatus.controller)) {
			m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_INIT;
		}

		break;

	// 魔法ダイアログ表示中
	case m11RPGwj_SystemStatus.COMMANDSTATE_MAGICMENU:

		// 選択結果に応じた処理へ
		if (m11RPGwj_systemStatus.magicDlg.process(m11RPGwj_systemStatus.controller)) {

			switch (m11RPGwj_systemStatus.magicDlg.getIndex()) {

			// 戻る
			case -1:
			case 0:

				m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_INIT;

				break;

			// 魔法選択
			default:

				m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_MAGIC_DONE_IN;

				break;

			}

		}

		break;

	// 魔法メニュー選択
	case m11RPGwj_SystemStatus.COMMANDSTATE_MAGIC_DONE_IN:

		// リターンキー解放を待つ
		if (m11RPGwj_systemStatus.controller.getButtons() != 0) {
			return;
		}

		item = m11RPGwj_playerStatus.magicList[m11RPGwj_systemStatus.magicDlg.getIndex() - 1];

		if (m11RPGwj_playerStatus.status.mp < item.mp) {
			m11RPGwj_systemStatus.commandMessage.setText("MPが足りない！", m11RPGwj_systemStatus.viewContext);
		} else {

			m11RPGwj_playerStatus.status.mp -= item.mp;

			if (item.player_effect_type == 'heal') {

				m11RPGwj_playerStatus.status.hp += m11RPGwj_getValue(item.player_effect, null);

				if (m11RPGwj_playerStatus.status.hp > m11RPGwj_playerStatus.status.mhp) {
					m11RPGwj_playerStatus.status.hp = m11RPGwj_playerStatus.status.mhp;
				}

			}

			m11RPGwj_systemStatus.commandMessage.setText(item.name + "の魔法をかけた", m11RPGwj_systemStatus.viewContext);

			m11RPGwj_updateStatus();

		}

		winx = (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols - m11RPGwj_systemStatus.commandMessage.getWidth()) / 2;
		winy = (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows - m11RPGwj_systemStatus.commandMessage.getHeight()) / 2;

		m11RPGwj_systemStatus.commandMessage.setPos(winx, winy);

		m11RPGwj_systemStatus.commandMessage.show();

		m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_MAGIC_DONE;

		break;

	// 魔法発動
	case m11RPGwj_SystemStatus.COMMANDSTATE_MAGIC_DONE:

		if (m11RPGwj_systemStatus.commandMessage.process(m11RPGwj_systemStatus.controller)) {
			m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_INIT;
		}

		break;

	// 状態ウインドウ準備
	case m11RPGwj_SystemStatus.COMMANDSTATE_STATUS_INIT:

		// リターンキー解放を待つ
		if (m11RPGwj_systemStatus.controller.getButtons() == 0) {

			var status = "武器:";

			if (m11RPGwj_playerStatus.itemHolder.getEquipItem(m11RPGwj_PlayerItem.ITEMTYPE_1HAND) == null) {
				status += "なし" + "<:br>";
			} else {
				status += m11RPGwj_playerStatus.itemHolder.getEquipItem(m11RPGwj_PlayerItem.ITEMTYPE_1HAND).name + "<:br>";
			}

			if (m11RPGwj_playerStatus.itemHolder.getEquipItem(m11RPGwj_PlayerItem.ITEMTYPE_ARMOR) == null) {
				status += "鎧:なし" + "<:br>";
			} else {
				status += "鎧:" + m11RPGwj_playerStatus.itemHolder.getEquipItem(m11RPGwj_PlayerItem.ITEMTYPE_ARMOR).name + "<:br>";
			}

			if (m11RPGwj_playerStatus.itemHolder.getEquipItem(m11RPGwj_PlayerItem.ITEMTYPE_SHIELD) == null) {
				status += "盾:なし" + "<:br>";
			} else {
				status += "盾:" + m11RPGwj_playerStatus.itemHolder.getEquipItem(m11RPGwj_PlayerItem.ITEMTYPE_SHIELD).name + "<:br>";
			}

			status += "攻撃力:" + m11RPGwj_playerStatus.status.at + "<:br>";
			status += "守備力:" + m11RPGwj_playerStatus.status.def + "<:br>";
			status += "魔力:" + m11RPGwj_playerStatus.status.mf;

			m11RPGwj_systemStatus.commandMessage.setText(status, m11RPGwj_systemStatus.viewContext);
			m11RPGwj_systemStatus.commandMessage.pageDone();

			winx = (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols - m11RPGwj_systemStatus.commandMessage.getWidth()) / 2;
			winy = (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows - m11RPGwj_systemStatus.commandMessage.getHeight()) / 2;

			m11RPGwj_systemStatus.commandMessage.setPos(winx, winy);

			m11RPGwj_systemStatus.commandMessage.show();

			m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_STATUS_VIEW;

		}

		break;

	// 状態ウインドウ表示
	case m11RPGwj_SystemStatus.COMMANDSTATE_STATUS_VIEW:

		if (m11RPGwj_systemStatus.commandMessage.process(m11RPGwj_systemStatus.controller)) {
			m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_INIT;
		}

		break;

	case m11RPGwj_SystemStatus.COMMANDSTATE_SAVE_EXEC:

		// リターンキー解放を待つ
		if (m11RPGwj_systemStatus.controller.getButtons() == 0) {

			var status_data = m11RPGwj_playerStatus.getStatusData();
			var item_data = m11RPGwj_playerStatus.getItemData();
			var bgm_data = "";
			var vars_data = new String();

			if (m11RPGwj_playerStatus.bgm) {
				bgm_data = m11RPGwj_playerStatus.bgm;
			}

			for (i = 0;i < m11RPGwj_playerStatus.varList.length;i++) {

				if (i != 0) {
					vars_data += ",";
				}

				vars_data += m11RPGwj_playerStatus.varList[i];

			}


			var save_data = 'gameID=' + m11RPGwj_config.gameID + "\n";
			save_data += 'gameVer=' + m11RPGwj_config.gameVer + "\n";
			save_data += 'saveVer=' + m11RPGwj_config.saveVer + "\n";
			save_data += 'formatVer=1' + "\n";
			save_data += "status=" + status_data + "\n";
			save_data += "item=" + item_data + "\n";
			save_data += "bgm=" + bgm_data + "\n";
			save_data += "vars=" + vars_data + "\n";

			if (localStorage) {
				localStorage.setItem("m11RPGwj_saveData", save_data);
			}

			if (localStorage && localStorage.getItem("m11RPGwj_saveData")) {
				m11RPGwj_systemStatus.commandMessage.setText("保存しました", m11RPGwj_systemStatus.viewContext);
			} else {
				m11RPGwj_systemStatus.commandMessage.setText("保存できませんでした", m11RPGwj_systemStatus.viewContext);
			}

			winx = (m11RPGwj_config.chip_width * m11RPGwj_config.view_cols - m11RPGwj_systemStatus.commandMessage.getWidth()) / 2;
			winy = (m11RPGwj_config.chip_height * m11RPGwj_config.view_rows - m11RPGwj_systemStatus.commandMessage.getHeight()) / 2;

			m11RPGwj_systemStatus.commandMessage.setPos(winx, winy);

			m11RPGwj_systemStatus.commandMessage.show();

			m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_SAVE_DONE;

		}

		break;

	// 保存完了メッセージ表示
	case m11RPGwj_SystemStatus.COMMANDSTATE_SAVE_DONE:

		if (m11RPGwj_systemStatus.commandMessage.process(m11RPGwj_systemStatus.controller)) {
			m11RPGwj_systemStatus.command_status = m11RPGwj_SystemStatus.COMMANDSTATE_INIT;
		}

		break;

	}

	return false;

}

// 描画関数
function m11RPGwj_draw(context) {

	var i, j;

	context.globalAlpha = 1.0;
	context.clearRect(0, 0, m11RPGwj_systemStatus.viewCanvas.width, m11RPGwj_systemStatus.viewCanvas.height);

	switch (m11RPGwj_systemStatus.app_status) {

	case m11RPGwj_SystemStatus.APPSTATE_DEMO:

		context.textAlign = 'center';
		context.textBaseline = 'middle';

		context.font = '16px fixed';

		i = m11RPGwj_systemStatus.process_count % 64;

		context.fillStyle = 'RGB(' + (128 + i * 2) + ',' + (192 - i * 2) + ',' + (192 + i) + ')';

		context.fillText('開始ボタンでゲーム開始', m11RPGwj_config.view_center_x, m11RPGwj_config.view_center_y);

		break;

	case m11RPGwj_SystemStatus.APPSTATE_LOADING:

		break;

	case m11RPGwj_SystemStatus.APPSTATE_TITLE:

		if (m11RPGwj_systemStatus.loaded_image != null) {
			context.drawImage(m11RPGwj_systemStatus.loaded_image, m11RPGwj_config.view_center_x - Math.floor(m11RPGwj_systemStatus.loaded_image.width / 2), m11RPGwj_config.view_center_y - Math.floor(m11RPGwj_systemStatus.loaded_image.height / 2));
		}

		m11RPGwj_systemStatus.controller.draw(context);

		break;

	case m11RPGwj_SystemStatus.APPSTATE_START:

		m11RPGwj_systemStatus.titleDlg.draw(context);

		m11RPGwj_systemStatus.controller.draw(context);

		break;

	case m11RPGwj_SystemStatus.APPSTATE_GAME:

		if (m11RPGwj_systemStatus.flash_count > 0) {
			if (m11RPGwj_systemStatus.flash_count < 3) {
				context.globalAlpha = 1 - (0.4 * m11RPGwj_systemStatus.flash_count);
			} else {
				context.globalAlpha = (m11RPGwj_systemStatus.flash_count - 2) / 16;
			}
		}

		if (m11RPGwj_systemStatus.move_count > 0) {

			if (m11RPGwj_systemStatus.move_count < 5) {
				context.globalAlpha = (5 - m11RPGwj_systemStatus.move_count) * 0.2;
			}

			if (m11RPGwj_systemStatus.move_count == 5 || m11RPGwj_systemStatus.move_count == 6) {
				context.globalAlpha = 0.1;
			}

			if (m11RPGwj_systemStatus.move_count > 6) {
				context.globalAlpha = (m11RPGwj_systemStatus.move_count - 6) * 0.2;
			}

		}

		var chip_index, chip_col, chip_row;

		// 表示canvas上にマップの地形を描画
		for (i = 0;i < m11RPGwj_systemStatus.v_rows;i++) {
			for (j= 0;j < m11RPGwj_systemStatus.v_cols;j++) {

				// 描画対象となるチップを決定
				chip_index = m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].chipMap[(m11RPGwj_systemStatus.v_x - m11RPGwj_config.view_range_x + j) + (m11RPGwj_systemStatus.v_y - m11RPGwj_config.view_range_y + i) * m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].cols];

				// チップ画像の位置を算出
				chip_col = chip_index % 8;
				chip_row = Math.floor(chip_index / 8);

				// チップ画像を描画
				if (m11RPGwj_data.chip_imageList == null) {
					context.drawImage(m11RPGwj_data.chipImage, chip_col * m11RPGwj_config.chip_width, chip_row * m11RPGwj_config.chip_height, m11RPGwj_config.chip_width, m11RPGwj_config.chip_height, m11RPGwj_systemStatus.sx + (-m11RPGwj_systemStatus.dx * m11RPGwj_systemStatus.scroll_pos) + j * m11RPGwj_config.chip_width, m11RPGwj_systemStatus.sy + (-m11RPGwj_systemStatus.dy * m11RPGwj_systemStatus.scroll_pos) + i * m11RPGwj_config.chip_height, m11RPGwj_config.chip_width, m11RPGwj_config.chip_height);
				} else {
					context.putImageData(m11RPGwj_data.chip_imageList[chip_index], m11RPGwj_systemStatus.sx + (-m11RPGwj_systemStatus.dx * m11RPGwj_systemStatus.scroll_pos) + j * m11RPGwj_config.chip_width, m11RPGwj_systemStatus.sy + (-m11RPGwj_systemStatus.dy * m11RPGwj_systemStatus.scroll_pos) + i * m11RPGwj_config.chip_height);
				}

				var ev = null;

				// 指定位置のイベント情報オブジェクトを取得
				if (m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].eventMap[(m11RPGwj_systemStatus.v_x - m11RPGwj_config.view_range_x + j)  + (m11RPGwj_systemStatus.v_y - m11RPGwj_config.view_range_y + i) * m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].cols] >= 0) {
					ev = m11RPGwj_data.eventList[m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].eventMap[(m11RPGwj_systemStatus.v_x - m11RPGwj_config.view_range_x + j)  + (m11RPGwj_systemStatus.v_y - m11RPGwj_config.view_range_y + i) * m11RPGwj_data.mapList[m11RPGwj_playerStatus.map].cols]];
				}

				// イベントキャラクタがあれば描画
				if (ev != null && (ev.cond == null || m11RPGwj_playerStatus.varList[ev.cond[0]] == ev.cond[1]) && ev.chr >= 0) {

					// チップ画像の位置を算出
					chip_col = ev.chr % 8;
					chip_row = Math.floor(ev.chr / 8);

					context.drawImage(m11RPGwj_data.charImage, chip_col * m11RPGwj_config.chip_width, chip_row * m11RPGwj_config.chip_height, m11RPGwj_config.chip_width, m11RPGwj_config.chip_height, m11RPGwj_systemStatus.sx + (-m11RPGwj_systemStatus.dx * m11RPGwj_systemStatus.scroll_pos) + j * m11RPGwj_config.chip_width, m11RPGwj_systemStatus.sy + (-m11RPGwj_systemStatus.dy * m11RPGwj_systemStatus.scroll_pos) + i * m11RPGwj_config.chip_height, m11RPGwj_config.chip_width, m11RPGwj_config.chip_height);

				}

			}
		}

		// 主人公のキャラクタ画像を描画
		context.drawImage(m11RPGwj_data.charImage, (m11RPGwj_playerStatus.char_no % 8) * m11RPGwj_config.chip_width, Math.floor(m11RPGwj_playerStatus.char_no / 8) * m11RPGwj_config.chip_height, m11RPGwj_config.chip_width, m11RPGwj_config.chip_height, m11RPGwj_config.chr_x, m11RPGwj_config.chr_y, m11RPGwj_config.chip_width, m11RPGwj_config.chip_height);

		// 敵画像を描画
		if (m11RPGwj_systemStatus.event_enemy != null) {
			context.drawImage(m11RPGwj_data.enemyImageList[m11RPGwj_systemStatus.event_enemy.image], Math.floor(m11RPGwj_systemStatus.scriptMeswin.getX() + (m11RPGwj_systemStatus.scriptMeswin.getWidth() / 2) - (m11RPGwj_data.enemyImageList[m11RPGwj_systemStatus.event_enemy.image].width / 2)), m11RPGwj_systemStatus.scriptMeswin.getY() - m11RPGwj_data.enemyImageList[m11RPGwj_systemStatus.event_enemy.image].height);
		}

		// イベント用部品を描画
		m11RPGwj_systemStatus.scriptMeswin.draw(context);
		m11RPGwj_systemStatus.scriptSelectDlg.draw(context);

		// スクリプトimageを描画
		if (m11RPGwj_systemStatus.scriptContext != null && (m11RPGwj_systemStatus.scriptContext.stage == m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_VIEW || m11RPGwj_systemStatus.scriptContext.stage == m11RPGwj_ScriptContext.SCRIPTCODESTAGE_IMAGE_EXIT)) {
			context.drawImage(m11RPGwj_systemStatus.loaded_image, m11RPGwj_config.view_center_x - Math.floor(m11RPGwj_systemStatus.loaded_image.width / 2), m11RPGwj_config.view_center_y - Math.floor(m11RPGwj_systemStatus.loaded_image.height / 2));
		}

		if (m11RPGwj_systemStatus.scriptContext != null && m11RPGwj_systemStatus.scriptContext.stage == m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_ITEMMENU) {
				m11RPGwj_systemStatus.itemDlg.draw(context);
		}

		if (m11RPGwj_systemStatus.scriptContext != null && m11RPGwj_systemStatus.scriptContext.stage == m11RPGwj_ScriptContext.SCRIPTCODESTAGE_BATTLE_MAGICMENU) {
				m11RPGwj_systemStatus.magicDlg.draw(context);
		}

		// コマンドダイアログ描画
		if (m11RPGwj_systemStatus.game_status == m11RPGwj_SystemStatus.GMAESTATE_COMMAND) {

			m11RPGwj_systemStatus.commandDlg.draw(context);

			if (m11RPGwj_systemStatus.command_status == m11RPGwj_SystemStatus.COMMANDSTATE_ITEMMENU) {
				m11RPGwj_systemStatus.itemDlg.draw(context);
			}

			if (m11RPGwj_systemStatus.command_status == m11RPGwj_SystemStatus.COMMANDSTATE_MAGICMENU) {
				m11RPGwj_systemStatus.magicDlg.draw(context);
			}

			if (m11RPGwj_systemStatus.command_status == m11RPGwj_SystemStatus.COMMANDSTATE_ITEM_DONE || m11RPGwj_systemStatus.command_status == m11RPGwj_SystemStatus.COMMANDSTATE_MAGIC_DONE || m11RPGwj_systemStatus.command_status == m11RPGwj_SystemStatus.COMMANDSTATE_STATUS_VIEW || m11RPGwj_systemStatus.command_status == m11RPGwj_SystemStatus.COMMANDSTATE_SAVE_DONE) {
				m11RPGwj_systemStatus.commandMessage.draw(context);
			}

		}

		// ステータス描画位置設定
		var status_y = m11RPGwj_systemStatus.viewCanvas.height - m11RPGwj_config.status_height;

		context.globalAlpha = 1.0;

		context.fillStyle = "#000000";
		context.fillRect(0, status_y, m11RPGwj_systemStatus.viewCanvas.width, m11RPGwj_config.status_height);

		// ステータス文字列の描画設定
		context.font = m11RPGwj_config.status_font;
		context.fillStyle = "#ffffff";
		context.textBaseline = 'middle';

		context.fillText("HP:" + m11RPGwj_playerStatus.status.hp + "/" + m11RPGwj_playerStatus.status.mhp, 2, status_y + m11RPGwj_config.status_height / 2);
		context.fillText("MP:" + m11RPGwj_playerStatus.status.mp + "/" + m11RPGwj_playerStatus.status.mmp, 2 + m11RPGwj_config.status_char_width * 5, status_y + m11RPGwj_config.status_height / 2);
		context.fillText("経験値:" + m11RPGwj_playerStatus.status.exp, 2 + m11RPGwj_config.status_char_width * 19, status_y + m11RPGwj_config.status_height / 2);

		m11RPGwj_systemStatus.controller.draw(context);

		break;

	case m11RPGwj_SystemStatus.APPSTATE_END:

		if (m11RPGwj_systemStatus.loaded_image != null) {
			context.drawImage(m11RPGwj_systemStatus.loaded_image, m11RPGwj_config.view_center_x - Math.floor(m11RPGwj_systemStatus.loaded_image.width / 2), m11RPGwj_config.view_center_y - Math.floor(m11RPGwj_systemStatus.loaded_image.height / 2));
		}

		break;

	}

}
